/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 79 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 222 "cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DROP = 3,                       /* DROP  */
  YYSYMBOL_ASSERT = 4,                     /* ASSERT  */
  YYSYMBOL_EXIT = 5,                       /* EXIT  */
  YYSYMBOL_RETURN = 6,                     /* RETURN  */
  YYSYMBOL_LOG_TOK = 7,                    /* LOG_TOK  */
  YYSYMBOL_ERROR = 8,                      /* ERROR  */
  YYSYMBOL_ROUTE = 9,                      /* ROUTE  */
  YYSYMBOL_ROUTE_FAILURE = 10,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 11,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_BRANCH = 12,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_ERROR = 13,               /* ROUTE_ERROR  */
  YYSYMBOL_ROUTE_LOCAL = 14,               /* ROUTE_LOCAL  */
  YYSYMBOL_ROUTE_STARTUP = 15,             /* ROUTE_STARTUP  */
  YYSYMBOL_ROUTE_TIMER = 16,               /* ROUTE_TIMER  */
  YYSYMBOL_ROUTE_EVENT = 17,               /* ROUTE_EVENT  */
  YYSYMBOL_IF = 18,                        /* IF  */
  YYSYMBOL_ELSE = 19,                      /* ELSE  */
  YYSYMBOL_SWITCH = 20,                    /* SWITCH  */
  YYSYMBOL_CASE = 21,                      /* CASE  */
  YYSYMBOL_DEFAULT = 22,                   /* DEFAULT  */
  YYSYMBOL_BREAK = 23,                     /* BREAK  */
  YYSYMBOL_WHILE = 24,                     /* WHILE  */
  YYSYMBOL_FOR = 25,                       /* FOR  */
  YYSYMBOL_IN = 26,                        /* IN  */
  YYSYMBOL_NULLV = 27,                     /* NULLV  */
  YYSYMBOL_XDBG = 28,                      /* XDBG  */
  YYSYMBOL_XLOG = 29,                      /* XLOG  */
  YYSYMBOL_XLOG_BUF_SIZE = 30,             /* XLOG_BUF_SIZE  */
  YYSYMBOL_XLOG_FORCE_COLOR = 31,          /* XLOG_FORCE_COLOR  */
  YYSYMBOL_XLOG_PRINT_LEVEL = 32,          /* XLOG_PRINT_LEVEL  */
  YYSYMBOL_XLOG_LEVEL = 33,                /* XLOG_LEVEL  */
  YYSYMBOL_PV_PRINT_BUF_SIZE = 34,         /* PV_PRINT_BUF_SIZE  */
  YYSYMBOL_DEBUG_MODE = 35,                /* DEBUG_MODE  */
  YYSYMBOL_ENABLE_ASSERTS = 36,            /* ENABLE_ASSERTS  */
  YYSYMBOL_ABORT_ON_ASSERT = 37,           /* ABORT_ON_ASSERT  */
  YYSYMBOL_LOGLEVEL = 38,                  /* LOGLEVEL  */
  YYSYMBOL_LOGPREFIX = 39,                 /* LOGPREFIX  */
  YYSYMBOL_LOGSTDOUT = 40,                 /* LOGSTDOUT  */
  YYSYMBOL_LOGSTDERROR = 41,               /* LOGSTDERROR  */
  YYSYMBOL_LOGFACILITY = 42,               /* LOGFACILITY  */
  YYSYMBOL_LOGNAME = 43,                   /* LOGNAME  */
  YYSYMBOL_AVP_ALIASES = 44,               /* AVP_ALIASES  */
  YYSYMBOL_LISTEN = 45,                    /* LISTEN  */
  YYSYMBOL_SOCKET = 46,                    /* SOCKET  */
  YYSYMBOL_MEMGROUP = 47,                  /* MEMGROUP  */
  YYSYMBOL_ALIAS = 48,                     /* ALIAS  */
  YYSYMBOL_AUTO_ALIASES = 49,              /* AUTO_ALIASES  */
  YYSYMBOL_TAG = 50,                       /* TAG  */
  YYSYMBOL_DNS = 51,                       /* DNS  */
  YYSYMBOL_REV_DNS = 52,                   /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 53,              /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 54,             /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_RETR_TIME = 55,             /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_RETR_NO = 56,               /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 57,            /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 58,            /* DNS_USE_SEARCH  */
  YYSYMBOL_MAX_WHILE_LOOPS = 59,           /* MAX_WHILE_LOOPS  */
  YYSYMBOL_UDP_WORKERS = 60,               /* UDP_WORKERS  */
  YYSYMBOL_CHECK_VIA = 61,                 /* CHECK_VIA  */
  YYSYMBOL_SHM_HASH_SPLIT_PERCENTAGE = 62, /* SHM_HASH_SPLIT_PERCENTAGE  */
  YYSYMBOL_SHM_SECONDARY_HASH_SIZE = 63,   /* SHM_SECONDARY_HASH_SIZE  */
  YYSYMBOL_MEM_WARMING_ENABLED = 64,       /* MEM_WARMING_ENABLED  */
  YYSYMBOL_MEM_WARMING_PATTERN_FILE = 65,  /* MEM_WARMING_PATTERN_FILE  */
  YYSYMBOL_MEM_WARMING_PERCENTAGE = 66,    /* MEM_WARMING_PERCENTAGE  */
  YYSYMBOL_RPM_MEM_FILE = 67,              /* RPM_MEM_FILE  */
  YYSYMBOL_RPM_MEM_SIZE = 68,              /* RPM_MEM_SIZE  */
  YYSYMBOL_MEMLOG = 69,                    /* MEMLOG  */
  YYSYMBOL_MEMDUMP = 70,                   /* MEMDUMP  */
  YYSYMBOL_EXECMSGTHRESHOLD = 71,          /* EXECMSGTHRESHOLD  */
  YYSYMBOL_EXECDNSTHRESHOLD = 72,          /* EXECDNSTHRESHOLD  */
  YYSYMBOL_TCPTHRESHOLD = 73,              /* TCPTHRESHOLD  */
  YYSYMBOL_EVENT_SHM_THRESHOLD = 74,       /* EVENT_SHM_THRESHOLD  */
  YYSYMBOL_EVENT_PKG_THRESHOLD = 75,       /* EVENT_PKG_THRESHOLD  */
  YYSYMBOL_QUERYBUFFERSIZE = 76,           /* QUERYBUFFERSIZE  */
  YYSYMBOL_QUERYFLUSHTIME = 77,            /* QUERYFLUSHTIME  */
  YYSYMBOL_SIP_WARNING = 78,               /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 79,          /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 80,             /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 81,         /* USER_AGENT_HEADER  */
  YYSYMBOL_LOADMODULE = 82,                /* LOADMODULE  */
  YYSYMBOL_MPATH = 83,                     /* MPATH  */
  YYSYMBOL_MODPARAM = 84,                  /* MODPARAM  */
  YYSYMBOL_MAXBUFFER = 85,                 /* MAXBUFFER  */
  YYSYMBOL_CHROOT = 86,                    /* CHROOT  */
  YYSYMBOL_WDIR = 87,                      /* WDIR  */
  YYSYMBOL_MHOMED = 88,                    /* MHOMED  */
  YYSYMBOL_POLL_METHOD = 89,               /* POLL_METHOD  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 90,        /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_WORKERS = 91,               /* TCP_WORKERS  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 92,       /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 93,          /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_SOCKET_BACKLOG = 94,        /* TCP_SOCKET_BACKLOG  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 95,       /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_NEW_CONN_BFLAG = 96,     /* TCP_NO_NEW_CONN_BFLAG  */
  YYSYMBOL_TCP_NO_NEW_CONN_RPLFLAG = 97,   /* TCP_NO_NEW_CONN_RPLFLAG  */
  YYSYMBOL_TCP_KEEPALIVE = 98,             /* TCP_KEEPALIVE  */
  YYSYMBOL_TCP_KEEPCOUNT = 99,             /* TCP_KEEPCOUNT  */
  YYSYMBOL_TCP_KEEPIDLE = 100,             /* TCP_KEEPIDLE  */
  YYSYMBOL_TCP_KEEPINTERVAL = 101,         /* TCP_KEEPINTERVAL  */
  YYSYMBOL_TCP_MAX_MSG_TIME = 102,         /* TCP_MAX_MSG_TIME  */
  YYSYMBOL_TCP_PARALLEL_READ_ON_WORKERS = 103, /* TCP_PARALLEL_READ_ON_WORKERS  */
  YYSYMBOL_ADVERTISED_ADDRESS = 104,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 105,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 106,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 107,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_MCAST_LOOPBACK = 108,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 109,                /* MCAST_TTL  */
  YYSYMBOL_TOS = 110,                      /* TOS  */
  YYSYMBOL_DISABLE_DNS_FAILOVER = 111,     /* DISABLE_DNS_FAILOVER  */
  YYSYMBOL_DISABLE_DNS_BLACKLIST = 112,    /* DISABLE_DNS_BLACKLIST  */
  YYSYMBOL_DST_BLACKLIST = 113,            /* DST_BLACKLIST  */
  YYSYMBOL_DISABLE_STATELESS_FWD = 114,    /* DISABLE_STATELESS_FWD  */
  YYSYMBOL_DB_VERSION_TABLE = 115,         /* DB_VERSION_TABLE  */
  YYSYMBOL_DB_DEFAULT_URL = 116,           /* DB_DEFAULT_URL  */
  YYSYMBOL_DB_MAX_ASYNC_CONNECTIONS = 117, /* DB_MAX_ASYNC_CONNECTIONS  */
  YYSYMBOL_DISABLE_503_TRANSLATION = 118,  /* DISABLE_503_TRANSLATION  */
  YYSYMBOL_SYNC_TOKEN = 119,               /* SYNC_TOKEN  */
  YYSYMBOL_ASYNC_TOKEN = 120,              /* ASYNC_TOKEN  */
  YYSYMBOL_LAUNCH_TOKEN = 121,             /* LAUNCH_TOKEN  */
  YYSYMBOL_AUTO_SCALING_PROFILE = 122,     /* AUTO_SCALING_PROFILE  */
  YYSYMBOL_AUTO_SCALING_CYCLE = 123,       /* AUTO_SCALING_CYCLE  */
  YYSYMBOL_TIMER_WORKERS = 124,            /* TIMER_WORKERS  */
  YYSYMBOL_EQUAL = 125,                    /* EQUAL  */
  YYSYMBOL_EQUAL_T = 126,                  /* EQUAL_T  */
  YYSYMBOL_GT = 127,                       /* GT  */
  YYSYMBOL_LT = 128,                       /* LT  */
  YYSYMBOL_GTE = 129,                      /* GTE  */
  YYSYMBOL_LTE = 130,                      /* LTE  */
  YYSYMBOL_DIFF = 131,                     /* DIFF  */
  YYSYMBOL_MATCH = 132,                    /* MATCH  */
  YYSYMBOL_NOTMATCH = 133,                 /* NOTMATCH  */
  YYSYMBOL_COLONEQ = 134,                  /* COLONEQ  */
  YYSYMBOL_PLUSEQ = 135,                   /* PLUSEQ  */
  YYSYMBOL_MINUSEQ = 136,                  /* MINUSEQ  */
  YYSYMBOL_SLASHEQ = 137,                  /* SLASHEQ  */
  YYSYMBOL_MULTEQ = 138,                   /* MULTEQ  */
  YYSYMBOL_MODULOEQ = 139,                 /* MODULOEQ  */
  YYSYMBOL_BANDEQ = 140,                   /* BANDEQ  */
  YYSYMBOL_BOREQ = 141,                    /* BOREQ  */
  YYSYMBOL_BXOREQ = 142,                   /* BXOREQ  */
  YYSYMBOL_OR = 143,                       /* OR  */
  YYSYMBOL_AND = 144,                      /* AND  */
  YYSYMBOL_BOR = 145,                      /* BOR  */
  YYSYMBOL_BAND = 146,                     /* BAND  */
  YYSYMBOL_BXOR = 147,                     /* BXOR  */
  YYSYMBOL_BLSHIFT = 148,                  /* BLSHIFT  */
  YYSYMBOL_BRSHIFT = 149,                  /* BRSHIFT  */
  YYSYMBOL_PLUS = 150,                     /* PLUS  */
  YYSYMBOL_MINUS = 151,                    /* MINUS  */
  YYSYMBOL_MULT = 152,                     /* MULT  */
  YYSYMBOL_MODULO = 153,                   /* MODULO  */
  YYSYMBOL_NOT = 154,                      /* NOT  */
  YYSYMBOL_BNOT = 155,                     /* BNOT  */
  YYSYMBOL_NUMBER = 156,                   /* NUMBER  */
  YYSYMBOL_ZERO = 157,                     /* ZERO  */
  YYSYMBOL_ID = 158,                       /* ID  */
  YYSYMBOL_STRING = 159,                   /* STRING  */
  YYSYMBOL_SCRIPTVAR = 160,                /* SCRIPTVAR  */
  YYSYMBOL_IPV6ADDR = 161,                 /* IPV6ADDR  */
  YYSYMBOL_IPV4ADDR = 162,                 /* IPV4ADDR  */
  YYSYMBOL_IPNET = 163,                    /* IPNET  */
  YYSYMBOL_COMMA = 164,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 165,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 166,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 167,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 168,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 169,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 170,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 171,                   /* RBRACK  */
  YYSYMBOL_SLASH = 172,                    /* SLASH  */
  YYSYMBOL_AS = 173,                       /* AS  */
  YYSYMBOL_USE_WORKERS = 174,              /* USE_WORKERS  */
  YYSYMBOL_USE_AUTO_SCALING_PROFILE = 175, /* USE_AUTO_SCALING_PROFILE  */
  YYSYMBOL_MAX = 176,                      /* MAX  */
  YYSYMBOL_MIN = 177,                      /* MIN  */
  YYSYMBOL_DOT = 178,                      /* DOT  */
  YYSYMBOL_CR = 179,                       /* CR  */
  YYSYMBOL_COLON = 180,                    /* COLON  */
  YYSYMBOL_ANY = 181,                      /* ANY  */
  YYSYMBOL_ANYCAST = 182,                  /* ANYCAST  */
  YYSYMBOL_FRAG = 183,                     /* FRAG  */
  YYSYMBOL_SCRIPTVARERR = 184,             /* SCRIPTVARERR  */
  YYSYMBOL_SCALE_UP_TO = 185,              /* SCALE_UP_TO  */
  YYSYMBOL_SCALE_DOWN_TO = 186,            /* SCALE_DOWN_TO  */
  YYSYMBOL_ON = 187,                       /* ON  */
  YYSYMBOL_CYCLES = 188,                   /* CYCLES  */
  YYSYMBOL_CYCLES_WITHIN = 189,            /* CYCLES_WITHIN  */
  YYSYMBOL_PERCENTAGE = 190,               /* PERCENTAGE  */
  YYSYMBOL_YYACCEPT = 191,                 /* $accept  */
  YYSYMBOL_cfg = 192,                      /* cfg  */
  YYSYMBOL_statements = 193,               /* statements  */
  YYSYMBOL_statement = 194,                /* statement  */
  YYSYMBOL_195_1 = 195,                    /* $@1  */
  YYSYMBOL_196_2 = 196,                    /* $@2  */
  YYSYMBOL_197_3 = 197,                    /* $@3  */
  YYSYMBOL_198_4 = 198,                    /* $@4  */
  YYSYMBOL_199_5 = 199,                    /* $@5  */
  YYSYMBOL_200_6 = 200,                    /* $@6  */
  YYSYMBOL_201_7 = 201,                    /* $@7  */
  YYSYMBOL_202_8 = 202,                    /* $@8  */
  YYSYMBOL_203_9 = 203,                    /* $@9  */
  YYSYMBOL_listen_id = 204,                /* listen_id  */
  YYSYMBOL_host_sep = 205,                 /* host_sep  */
  YYSYMBOL_host = 206,                     /* host  */
  YYSYMBOL_proto = 207,                    /* proto  */
  YYSYMBOL_port = 208,                     /* port  */
  YYSYMBOL_snumber = 209,                  /* snumber  */
  YYSYMBOL_phostport = 210,                /* phostport  */
  YYSYMBOL_panyhostport = 211,             /* panyhostport  */
  YYSYMBOL_alias_def = 212,                /* alias_def  */
  YYSYMBOL_id_lst = 213,                   /* id_lst  */
  YYSYMBOL_listen_id_def = 214,            /* listen_id_def  */
  YYSYMBOL_socket_def_param = 215,         /* socket_def_param  */
  YYSYMBOL_socket_def_params = 216,        /* socket_def_params  */
  YYSYMBOL_socket_def = 217,               /* socket_def  */
  YYSYMBOL_218_10 = 218,                   /* $@10  */
  YYSYMBOL_219_11 = 219,                   /* $@11  */
  YYSYMBOL_any_proto = 220,                /* any_proto  */
  YYSYMBOL_multi_string = 221,             /* multi_string  */
  YYSYMBOL_blst_elem = 222,                /* blst_elem  */
  YYSYMBOL_blst_elem_list = 223,           /* blst_elem_list  */
  YYSYMBOL_auto_scale_profile_def = 224,   /* auto_scale_profile_def  */
  YYSYMBOL_assign_stm = 225,               /* assign_stm  */
  YYSYMBOL_module_stm = 226,               /* module_stm  */
  YYSYMBOL_ip = 227,                       /* ip  */
  YYSYMBOL_ipv4 = 228,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 229,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 230,                     /* ipv6  */
  YYSYMBOL_ipnet = 231,                    /* ipnet  */
  YYSYMBOL_folded_string = 232,            /* folded_string  */
  YYSYMBOL_route_name = 233,               /* route_name  */
  YYSYMBOL_route_name_var = 234,           /* route_name_var  */
  YYSYMBOL_route_stm = 235,                /* route_stm  */
  YYSYMBOL_failure_route_stm = 236,        /* failure_route_stm  */
  YYSYMBOL_onreply_route_stm = 237,        /* onreply_route_stm  */
  YYSYMBOL_branch_route_stm = 238,         /* branch_route_stm  */
  YYSYMBOL_error_route_stm = 239,          /* error_route_stm  */
  YYSYMBOL_local_route_stm = 240,          /* local_route_stm  */
  YYSYMBOL_startup_route_stm = 241,        /* startup_route_stm  */
  YYSYMBOL_timer_route_stm = 242,          /* timer_route_stm  */
  YYSYMBOL_event_route_stm = 243,          /* event_route_stm  */
  YYSYMBOL_exp = 244,                      /* exp  */
  YYSYMBOL_equalop = 245,                  /* equalop  */
  YYSYMBOL_compop = 246,                   /* compop  */
  YYSYMBOL_matchop = 247,                  /* matchop  */
  YYSYMBOL_intop = 248,                    /* intop  */
  YYSYMBOL_strop = 249,                    /* strop  */
  YYSYMBOL_script_var = 250,               /* script_var  */
  YYSYMBOL_exp_elem = 251,                 /* exp_elem  */
  YYSYMBOL_exp_cond = 252,                 /* exp_cond  */
  YYSYMBOL_assignop = 253,                 /* assignop  */
  YYSYMBOL_assignexp = 254,                /* assignexp  */
  YYSYMBOL_assign_cmd = 255,               /* assign_cmd  */
  YYSYMBOL_exp_stm = 256,                  /* exp_stm  */
  YYSYMBOL_brk_stm = 257,                  /* brk_stm  */
  YYSYMBOL_stm = 258,                      /* stm  */
  YYSYMBOL_actions = 259,                  /* actions  */
  YYSYMBOL_brk_actions = 260,              /* brk_actions  */
  YYSYMBOL_action = 261,                   /* action  */
  YYSYMBOL_brk_action = 262,               /* brk_action  */
  YYSYMBOL_brk_if_cmd = 263,               /* brk_if_cmd  */
  YYSYMBOL_if_cmd = 264,                   /* if_cmd  */
  YYSYMBOL_while_cmd = 265,                /* while_cmd  */
  YYSYMBOL_foreach_cmd = 266,              /* foreach_cmd  */
  YYSYMBOL_switch_cmd = 267,               /* switch_cmd  */
  YYSYMBOL_switch_stm = 268,               /* switch_stm  */
  YYSYMBOL_case_stms = 269,                /* case_stms  */
  YYSYMBOL_case_stm = 270,                 /* case_stm  */
  YYSYMBOL_default_stm = 271,              /* default_stm  */
  YYSYMBOL_func_param = 272,               /* func_param  */
  YYSYMBOL_route_param = 273,              /* route_param  */
  YYSYMBOL_async_func = 274,               /* async_func  */
  YYSYMBOL_cmd = 275                       /* cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  208
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2080

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  191
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  85
/* YYNRULES -- Number of rules.  */
#define YYNRULES  474
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  910

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   445


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   483,   483,   486,   487,   488,   491,   492,   493,   493,
     494,   494,   495,   495,   496,   496,   497,   497,   498,   498,
     499,   499,   500,   500,   501,   501,   503,   506,   521,   530,
     545,   546,   549,   550,   564,   569,   579,   580,   583,   584,
     585,   589,   591,   593,   598,   604,   606,   610,   612,   614,
     616,   620,   623,   624,   627,   629,   631,   637,   640,   643,
     646,   649,   652,   657,   658,   661,   662,   663,   663,   668,
     668,   675,   676,   678,   679,   682,   690,   701,   702,   703,
     707,   715,   723,   729,   737,   741,   753,   754,   755,   756,
     757,   758,   762,   764,   767,   768,   772,   773,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   807,   808,   811,   815,   816,   817,   825,
     833,   841,   849,   857,   865,   873,   881,   889,   897,   900,
     901,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   925,   926,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   965,   975,   976,   981,   982,   985,   989,   990,   995,
     996,   999,  1000,  1003,  1004,  1007,  1008,  1015,  1016,  1023,
    1025,  1028,  1029,  1032,  1033,  1036,  1039,  1046,  1047,  1054,
    1055,  1062,  1063,  1065,  1066,  1070,  1071,  1074,  1075,  1077,
    1078,  1080,  1082,  1084,  1085,  1086,  1087,  1089,  1090,  1097,
    1100,  1108,  1111,  1155,  1156,  1161,  1163,  1165,  1166,  1172,
    1174,  1188,  1190,  1193,  1194,  1197,  1198,  1205,  1206,  1213,
    1214,  1218,  1246,  1247,  1249,  1250,  1253,  1254,  1257,  1258,
    1268,  1270,  1272,  1273,  1275,  1276,  1278,  1281,  1283,  1286,
    1287,  1290,  1292,  1295,  1298,  1302,  1303,  1309,  1315,  1319,
    1320,  1323,  1339,  1355,  1356,  1359,  1365,  1375,  1385,  1396,
    1399,  1408,  1413,  1436,  1441,  1449,  1465,  1468,  1474,  1477,
    1485,  1491,  1494,  1500,  1503,  1511,  1514,  1522,  1525,  1533,
    1536,  1549,  1552,  1558,  1563,  1564,  1565,  1566,  1567,  1568,
    1571,  1572,  1575,  1576,  1577,  1578,  1580,  1581,  1584,  1585,
    1588,  1589,  1590,  1593,  1609,  1614,  1615,  1616,  1618,  1623,
    1626,  1629,  1632,  1635,  1641,  1642,  1643,  1644,  1645,  1646,
    1647,  1648,  1649,  1650,  1654,  1655,  1656,  1657,  1658,  1659,
    1662,  1665,  1668,  1671,  1674,  1677,  1680,  1683,  1686,  1689,
    1692,  1695,  1708,  1721,  1736,  1737,  1738,  1739,  1740,  1743,
    1744,  1745,  1748,  1749,  1750,  1753,  1754,  1755,  1759,  1760,
    1761,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1774,
    1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1785,  1793,
    1803,  1811,  1821,  1829,  1847,  1856,  1857,  1859,  1860,  1863,
    1869,  1875,  1881,  1889,  1892,  1895,  1900,  1910,  1917,  1924,
    1934,  1939,  1946,  1956,  1961,  1968,  1980,  1985,  1990,  1995,
    2000,  2010,  2020,  2030,  2042,  2060,  2091,  2095,  2101,  2104,
    2105,  2106,  2107,  2108,  2110,  2112,  2114,  2116,  2118,  2119,
    2122,  2128,  2129,  2131,  2137,  2138,  2140,  2144,  2163,  2164,
    2166,  2189,  2225,  2227,  2230,  2232,  2234,  2236,  2238,  2240,
    2242,  2248,  2254,  2260,  2266
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DROP", "ASSERT",
  "EXIT", "RETURN", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL",
  "ROUTE_STARTUP", "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH",
  "CASE", "DEFAULT", "BREAK", "WHILE", "FOR", "IN", "NULLV", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL",
  "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS",
  "ABORT_ON_ASSERT", "LOGLEVEL", "LOGPREFIX", "LOGSTDOUT", "LOGSTDERROR",
  "LOGFACILITY", "LOGNAME", "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP",
  "ALIAS", "AUTO_ALIASES", "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6",
  "DNS_TRY_NAPTR", "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO",
  "DNS_USE_SEARCH", "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD", "TCPTHRESHOLD",
  "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE",
  "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER",
  "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM", "MAXBUFFER",
  "CHROOT", "WDIR", "MHOMED", "POLL_METHOD", "TCP_ACCEPT_ALIASES",
  "TCP_WORKERS", "TCP_CONNECT_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS", "TCP_NO_NEW_CONN_BFLAG",
  "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE", "TCP_KEEPCOUNT",
  "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "TCP_PARALLEL_READ_ON_WORKERS", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "DISABLE_DNS_FAILOVER", "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST",
  "DISABLE_STATELESS_FWD", "DB_VERSION_TABLE", "DB_DEFAULT_URL",
  "DB_MAX_ASYNC_CONNECTIONS", "DISABLE_503_TRANSLATION", "SYNC_TOKEN",
  "ASYNC_TOKEN", "LAUNCH_TOKEN", "AUTO_SCALING_PROFILE",
  "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL", "EQUAL_T", "GT", "LT",
  "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH", "COLONEQ", "PLUSEQ",
  "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ",
  "OR", "AND", "BOR", "BAND", "BXOR", "BLSHIFT", "BRSHIFT", "PLUS",
  "MINUS", "MULT", "MODULO", "NOT", "BNOT", "NUMBER", "ZERO", "ID",
  "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR", "IPNET", "COMMA",
  "SEMICOLON", "RPAREN", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK",
  "SLASH", "AS", "USE_WORKERS", "USE_AUTO_SCALING_PROFILE", "MAX", "MIN",
  "DOT", "CR", "COLON", "ANY", "ANYCAST", "FRAG", "SCRIPTVARERR",
  "SCALE_UP_TO", "SCALE_DOWN_TO", "ON", "CYCLES", "CYCLES_WITHIN",
  "PERCENTAGE", "$accept", "cfg", "statements", "statement", "$@1", "$@2",
  "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "listen_id", "host_sep",
  "host", "proto", "port", "snumber", "phostport", "panyhostport",
  "alias_def", "id_lst", "listen_id_def", "socket_def_param",
  "socket_def_params", "socket_def", "$@10", "$@11", "any_proto",
  "multi_string", "blst_elem", "blst_elem_list", "auto_scale_profile_def",
  "assign_stm", "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "ipnet",
  "folded_string", "route_name", "route_name_var", "route_stm",
  "failure_route_stm", "onreply_route_stm", "branch_route_stm",
  "error_route_stm", "local_route_stm", "startup_route_stm",
  "timer_route_stm", "event_route_stm", "exp", "equalop", "compop",
  "matchop", "intop", "strop", "script_var", "exp_elem", "exp_cond",
  "assignop", "assignexp", "assign_cmd", "exp_stm", "brk_stm", "stm",
  "actions", "brk_actions", "action", "brk_action", "brk_if_cmd", "if_cmd",
  "while_cmd", "foreach_cmd", "switch_cmd", "switch_stm", "case_stms",
  "case_stm", "default_stm", "func_param", "route_param", "async_func",
  "cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-779)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-414)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1901,   -69,   -61,   -30,   -21,    -9,     5,    13,    16,    26,
     186,   202,   212,   222,   232,   241,   251,   285,   290,   311,
     323,   324,   391,    23,   234,   337,   374,   458,   459,   415,
     494,   497,   499,   505,   518,   520,   536,   557,   565,   572,
     578,   591,   594,   606,   624,   625,   632,   640,   663,   667,
     672,   677,    88,   678,    70,   682,   685,   692,   693,   704,
     708,   712,   716,   719,   720,   723,   726,   732,   744,   751,
     753,   760,   761,   766,   768,   775,   789,   790,   791,   792,
     799,   523,   598,   802,   808,   810,   812,   815,   817,   830,
     832,   833,  -779,   155,  1772,  -779,   588,   629,   639,   655,
     638,   730,   707,   718,   770,  -779,  -779,  -779,   344,   345,
     347,   364,   354,   355,   362,   363,   610,    91,   369,   387,
      38,   104,   156,   338,   742,   235,   400,   401,   403,  -779,
     787,  -779,   813,  -779,   819,  -779,   821,  -779,   826,  -779,
     828,   405,   406,   407,   408,   411,   413,   122,   421,   128,
     424,   386,   402,   425,   426,   430,   437,   438,   444,   445,
     446,   450,   143,   157,  -779,  -779,   162,  -779,   807,   451,
     142,   148,   452,   226,   469,   470,   472,   479,   480,   485,
     146,   170,   516,   521,   522,   525,   527,   537,    25,   544,
     559,   577,   597,   608,   339,  -779,   829,  -779,   839,   838,
     841,   165,   171,   619,   620,   175,   630,   843,  -779,   -69,
    -779,    21,  -779,    11,  -779,    22,  -779,    12,  -779,    45,
    -779,    49,  -779,    57,  -779,    27,  -779,    42,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,   844,   845,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
     972,  -779,   824,   573,   616,  -779,  -779,  -779,   831,  -779,
     840,  -779,  -779,  -779,   847,   846,  -779,  -103,   857,  -779,
     543,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,   848,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,   854,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,   850,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,   858,  -779,  -779,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,   851,  -779,  -779,
    -779,   864,  -779,  1611,   700,  -779,   700,  -779,  1611,   700,
    -779,   700,  -779,  1611,  -779,  1611,  -779,  1611,  -779,   700,
    -779,   700,  -779,  -779,  -779,  1387,   657,   657,   233,   870,
     691,  -779,   340,   884,   691,  -779,   887,   888,   890,   881,
     896,   895,   889,   891,   893,   814,    72,    82,   109,   898,
     900,   911,   912,   913,   914,   915,   916,   111,  -779,  -779,
    -779,  1602,   892,   651,  -779,  -779,  -779,  -779,  -779,    20,
    -779,  -779,  -779,   897,   918,   734,   919,   920,   776,   818,
     859,   923,   924,   882,   904,   936,   691,   942,   941,  -779,
    -779,   657,  -779,  -779,  -779,   945,  -779,  -779,   922,  -779,
    -779,  -779,   946,  -779,   -45,   933,  -779,   934,  1235,   955,
    1105,  -779,  -779,  -779,   138,  -779,   302,  -779,    60,  1235,
     -86,  1235,   -86,   948,   950,   964,   964,  -779,    95,  1096,
    1097,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,  1403,
    -779,  -779,  -779,  -779,  -779,  -779,   957,   958,  -779,   961,
     963,  -779,  -779,  -779,   976,   965,   -68,    19,  -779,   956,
    -779,  -779,  -779,  -779,  -779,   101,   739,   970,   -57,  -779,
      30,   984,  -779,  1235,  1235,  1444,  1403,  -779,   -37,  1582,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,  -779,   975,   978,
     982,   983,   987,   986,   998,   997,  -779,   -99,  -779,    -7,
     999,   255,  1116,   -38,   183,   -24,   252,   118,  1000,   308,
    1001,  -779,   772,  -779,  -779,  -779,   528,  -779,  -779,  1403,
    -779,  1403,  -779,  1452,  -779,  1553,  -779,  1611,  1611,  1611,
    1611,   995,  1611,  -779,  -779,  -779,  -779,  -779,   102,  -779,
    -779,  1002,  1005,   -57,  -779,  -779,  1009,  -779,   -45,  -779,
    1021,  -779,   297,  -779,   901,  1512,  1235,  1235,  1016,  -779,
    -779,  -779,  -779,  -779,  -779,  -779,  -779,   295,   -66,  -779,
     610,   -34,  -779,  -779,  -779,  -779,  1019,  -779,  1020,  -779,
     514,  -779,  1486,  1014,  1277,   -86,  -779,  -779,  -779,  -779,
    1024,  -779,  -779,  -779,   159,   700,   700,  -779,  -779,  -779,
    -779,  -779,   856,  -779,  -779,  1218,  1403,  1403,  1403,  1403,
    1403,  1403,  1403,  1403,  1403,  1403,   943,   985,  1026,  1068,
    1017,  1110,  -779,  -779,  -779,  -779,  1023,   750,  -779,  1165,
    -779,  -779,  -779,  -779,  -779,  1027,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  1037,  1038,  -779,  -779,  -779,  -779,   542,
    1513,  1173,  -779,  1184,  1039,  1042,  -779,  1319,  1043,  -779,
    -779,  -779,  -779,  -779,  -779,    33,  1046,   254,   530,  1048,
    -779,   562,   604,   642,  -779,  -779,  -779,  -779,   662,   662,
     662,   662,   662,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  1611,  -779,   750,  1045,  1059,  -779,  -779,  -779,
     561,  -779,  -779,  1152,  1486,   803,  1047,   140,  -779,  1235,
    -779,  -779,   567,  -779,  -779,  -779,  -779,  1277,  -779,  -779,
    -779,  -779,  1063,  -779,  1061,  -779,  1193,  1060,   -68,   191,
    -779,  -779,  -779,  -779,  -779,  -779,  1049,  1052,  -779,  1054,
    -779,  -779,   519,  -779,  -779,  -779,  -779,  1057,  1069,  -779,
     -68,  1072,  1041,  1089,  1568,  1568,  1568,  1277,  -779,  -779,
    1082,  1066,  1091,  1062,   484,   526,   609,  1230,  1092,  1084,
    1067,  1101,  1277,  1093,  -779,  1102,  1073,  -779,  -779,  1109,
    1111,  1241,  1121,  1113,  1251,  1090,  1131,  -779,  1100,  -779
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,   263,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
       0,   108,     0,   110,     0,   112,     0,   114,     0,   116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   265,   264,     0,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   246,     0,   248,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     5,
       3,     0,     9,     0,    11,     0,    13,     0,    15,     0,
      17,     0,    19,     0,    21,     0,    23,     0,    25,   213,
     210,   214,   211,   215,   212,   217,     0,     0,    38,   216,
     209,   208,    92,    91,    88,    87,    90,    89,    84,    86,
      85,    94,    93,    96,    95,    98,    97,   100,    99,   221,
       0,    35,     0,    66,    65,   220,   219,   218,     0,   225,
      32,    28,   272,   271,     0,     0,    47,    29,     0,    51,
      52,   224,    27,   269,   273,   270,   227,   226,   102,   101,
     104,   103,   105,   107,   109,   111,   113,   115,   118,   117,
     123,   121,   127,   126,   129,   128,   131,   130,   133,   132,
     135,   134,   137,   136,   139,   138,   141,   140,   143,   142,
     145,   144,   147,   146,   149,   148,   151,   150,   153,   152,
     155,   154,   157,   156,   159,   158,   161,   160,   203,   202,
     205,   204,   207,   206,   244,   243,     0,   120,   119,   164,
     163,   162,   167,   166,   165,   169,   168,   172,   170,   171,
     174,   173,   177,   175,   179,   178,   181,   180,   183,   182,
     185,   184,   187,   186,   189,   188,   191,   190,   197,   196,
     199,   198,   201,   200,   193,   192,   195,   194,   229,    32,
     228,   231,   230,   233,   232,   235,   234,   237,   236,   239,
     238,   242,   240,   241,   245,   247,     0,   250,   252,   251,
     254,   253,   256,   255,   258,   257,   260,     0,   259,   262,
     261,   124,   286,     0,     0,   288,     0,   291,     0,     0,
     293,     0,   295,     0,   297,     0,   299,     0,   301,     0,
     303,     0,    39,    40,    44,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,    53,     0,     0,     0,     0,
       0,     0,   439,     0,   441,   448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   323,   387,
     324,     0,     0,     0,   376,   382,   383,   384,   385,     0,
     280,   279,   281,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    41,     0,     0,     0,     0,    57,
      58,    63,    70,    68,   223,    73,   222,   274,    48,    34,
      33,   122,     0,   176,     0,     0,   125,     0,     0,     0,
       0,   445,   443,   451,     0,   454,     0,   458,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   463,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     386,   377,   284,   375,   388,   381,     0,     0,   289,     0,
       0,   294,   296,   298,     0,     0,     0,     0,    61,    54,
      60,    59,    62,    64,    74,     0,     0,     0,     0,    78,
       0,     0,   440,     0,     0,     0,     0,   327,     0,   328,
     309,   325,   366,   326,   365,   364,   442,   447,     0,     0,
       0,     0,     0,     0,     0,     0,   282,     0,   283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   415,   417,   460,   420,   423,     0,   362,   363,     0,
     345,     0,   344,   346,   347,   361,   348,     0,     0,     0,
       0,     0,     0,    36,    37,    46,    43,    42,     0,    50,
      49,     0,     0,     0,    71,    72,     0,    79,     0,   249,
       0,   306,     0,   368,     0,     0,     0,     0,     0,   310,
     312,   313,   314,   315,   311,   316,   317,   318,   319,   322,
       0,     0,   446,   444,   452,   449,     0,   455,     0,   459,
       0,   456,     0,     0,     0,     0,   277,   464,   278,   465,
       0,   466,   467,   437,     0,     0,     0,   474,   462,   418,
     421,   424,   419,   461,   359,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,    55,   266,   267,     0,     0,    77,     0,
     307,   367,   308,   305,   304,     0,   332,   275,   276,   333,
     331,   330,   329,     0,     0,   428,   426,   427,   429,     0,
       0,   400,   372,     0,     0,     0,   396,     0,     0,   402,
     369,   391,   392,   393,   394,     0,     0,     0,     0,     0,
     434,     0,     0,     0,   416,   422,   425,   360,   355,   354,
     356,   357,   358,   349,   350,   351,   353,   352,   285,   287,
     290,   292,     0,   302,     0,     0,     0,   438,   450,   453,
       0,   457,   374,     0,     0,     0,     0,   406,   408,     0,
     389,   371,     0,   379,   395,   397,   390,     0,   468,   469,
     436,   435,     0,   470,     0,   473,     0,     0,     0,     0,
     433,   430,   431,   432,   373,   401,     0,     0,   404,     0,
     407,   405,     0,   380,   370,   378,   403,     0,     0,   300,
       0,     0,    83,     0,   412,   410,   414,     0,   471,   472,
       0,     0,     0,    82,     0,     0,     0,   398,     0,     0,
       0,     0,     0,     0,    75,     0,     0,   399,    76,     0,
       0,     0,     0,     0,     0,     0,     0,    81,     0,    80
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -779,  -779,  -779,  1183,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -170,  -779,  -779,  -124,  -571,  -111,   515,
    -779,  -779,  1011,  -779,  -779,  -403,  1169,  -779,  -779,   633,
     778,   631,  -779,  -779,  -779,  -779,  -636,  -779,  1029,  -779,
    -714,  -424,  -384,  -779,  -779,  -779,  -779,  -779,  -779,  -779,
    -779,  -779,  -779,  -531,  -779,  -779,  -779,  -779,  -779,  -462,
    -779,  -512,  -779,   694,  -503,  -779,  -778,   474,  -426,    -1,
    -446,    -4,  -779,  -509,  -644,  -442,  -408,  -779,  -779,   477,
    -779,   593,  -779,   762,  -524
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   276,   453,   277,   262,   655,   642,   263,
     264,   280,   281,   580,   511,   512,   265,   447,   446,   666,
     516,   589,   590,   418,   105,   106,   282,   283,   284,   285,
     759,   624,   493,   617,   212,   214,   216,   218,   220,   222,
     224,   226,   228,   598,   687,   688,   689,   690,   691,   481,
     600,   644,   559,   645,   482,   603,   779,   771,   483,   832,
     484,   780,   781,   485,   486,   487,   488,   826,   827,   828,
     861,   636,   769,   628,   489
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     239,   278,   495,   532,   605,   248,   657,   498,   619,   499,
     621,   500,   425,   430,   660,   605,   601,   605,   390,   604,
     656,   564,   422,   427,   129,   602,   388,   601,   438,   601,
     604,   667,   604,   815,   835,   646,   602,   563,   602,   255,
     319,   321,   494,   440,   513,   496,   432,   497,   451,   563,
     434,   758,   563,   563,   563,   501,   107,   502,   436,   866,
     782,   615,   671,   672,   108,   700,   599,   701,   609,   605,
     605,   167,   646,   533,   478,   452,   618,   599,   620,   599,
     622,   601,   601,   535,   604,   604,   635,   743,   653,   164,
     602,   602,   249,  -321,  -321,   109,   630,   643,   480,   887,
     847,   261,   659,   742,   110,   257,   676,   677,   583,   587,
     537,   758,   547,   654,   897,   646,   111,   646,  -321,   713,
     626,   706,   588,   310,   664,   761,   478,   678,   707,   314,
     112,   599,   599,   782,   643,   706,   676,   677,   113,   610,
     710,   114,   711,   349,   340,   753,   754,   372,   130,   352,
     480,   115,   605,   605,   616,   208,   278,   259,   342,   702,
     789,   825,   859,   344,   601,   601,   408,   604,   604,   674,
     721,   374,   410,   602,   602,   653,   416,   643,   758,   643,
     785,   426,   431,   389,   271,   565,   272,   273,   782,   423,
     428,   424,   429,   782,   668,   274,   256,   439,   836,   669,
     654,   778,   646,   646,   646,   646,   646,   646,   646,   646,
     646,   646,   441,   433,   599,   599,   490,   435,   491,   492,
     478,   736,   737,   738,   739,   437,   741,   357,   563,   762,
     782,   782,   782,   782,   514,   131,   269,   168,   768,   534,
     782,   782,   782,   786,   480,   236,   237,   165,   782,   536,
     250,   238,   635,   785,   631,   478,   772,   653,   653,   632,
     796,   633,   783,   258,   643,   643,   643,   643,   643,   643,
     643,   643,   643,   643,   778,   504,   538,   871,   548,   480,
     518,   311,   654,   654,   504,   714,   788,   315,   236,   237,
     563,   563,   563,   563,   238,   563,   784,   611,   862,   880,
     350,   351,   341,   613,   373,   605,   353,   354,   785,   236,
     237,   116,   260,   785,   261,   238,   343,   601,   631,   478,
     604,   345,   756,   632,   409,   790,   602,   117,   375,   778,
     411,   792,   793,   417,   778,   783,   579,   118,   133,   266,
     401,   519,   708,   480,   823,   229,   231,   119,   233,   709,
     785,   785,   785,   785,   531,   240,   242,   120,   853,   132,
     785,   785,   785,   244,   246,   235,   121,   599,   785,   784,
     251,   778,   778,   778,   778,   135,   122,   563,   772,   872,
     873,   778,   778,   778,   358,   359,   846,   318,   253,   778,
     783,   260,   515,   270,   271,   783,   272,   273,   676,   677,
     563,   286,   288,   320,   290,   274,   298,   300,   302,   304,
     123,   708,   306,   706,   308,   124,   275,   597,   712,   608,
     838,   704,   312,   612,   784,   316,   322,   324,   597,   784,
     597,   326,   783,   783,   783,   783,   125,   634,   328,   330,
     676,   677,   783,   783,   783,   332,   334,   336,   126,   127,
     783,   338,   347,   355,  -320,  -320,   272,   273,   757,   137,
     139,   614,   134,   750,   665,   274,   784,   784,   784,   784,
     360,   362,   716,   364,   717,   662,   784,   784,   784,  -320,
     366,   368,   597,   597,   784,   863,   370,   462,   463,   464,
     465,   466,   467,   468,   260,   402,   261,   403,   -30,   136,
     230,   232,   774,   234,   470,  -411,  -411,   775,   471,   472,
     241,   243,   473,   474,   236,   237,   128,   376,   245,   247,
     238,   720,   378,   380,   195,   252,   382,   863,   384,   462,
     463,   464,   465,   466,   467,   468,   236,   237,   386,   665,
     141,   765,   238,   254,   774,   391,   470,  -409,  -409,   775,
     471,   472,   236,   237,   473,   474,   287,   289,   238,   291,
     393,   299,   301,   303,   305,   597,   597,   307,   863,   309,
     462,   463,   464,   465,   466,   467,   468,   313,   395,   760,
     317,   323,   325,   138,   140,   774,   327,   470,   850,   767,
     775,   471,   472,   329,   331,   473,   474,   211,   397,   197,
     333,   335,   337,   634,   475,   476,   339,   348,   356,   399,
     863,   795,   462,   463,   464,   465,   466,   467,   468,   142,
     412,   414,   143,   -69,   144,   361,   363,   774,   365,   470,
     145,   419,   775,   471,   472,   367,   369,   473,   474,   213,
     279,   371,   477,   146,   478,   147,   475,   476,   196,   776,
     215,   219,   561,  -411,   462,   463,   464,   465,   466,   467,
     468,   148,   676,   677,   236,   237,   -67,   217,   480,   469,
     238,   470,   377,   766,   478,   471,   472,   379,   381,   473,
     474,   383,   149,   385,   477,   877,   478,   475,   476,   708,
     150,   776,   722,   387,   723,  -409,   839,   151,   480,   260,
     392,   270,   271,   152,   272,   273,   820,   505,   821,   852,
     480,   236,   237,   274,   857,   394,   153,   238,   597,   154,
     851,   478,   223,   198,   275,   477,   722,   478,   841,   475,
     476,   155,   776,   396,   225,   561,   864,   462,   463,   464,
     465,   466,   467,   468,   221,   480,   -69,   -69,   -69,   156,
     157,   480,   469,   398,   470,   -69,   -69,   158,   471,   472,
     236,   237,   473,   474,   400,   159,   238,   477,   842,   478,
     843,   475,   476,   833,   776,   413,   415,   561,  -413,   462,
     463,   464,   465,   466,   467,   468,   420,   227,   160,   -67,
     -67,   -67,   161,   480,   469,   279,   470,   162,   -67,   -67,
     471,   472,   163,   166,   473,   474,   844,   169,   845,   477,
     170,   478,   731,   732,   733,   734,   479,   171,   172,   561,
     562,   462,   463,   464,   465,   466,   467,   468,   865,   173,
     506,   507,   508,   174,   735,   480,   469,   175,   470,   509,
     510,   176,   471,   472,   177,   178,   473,   474,   179,   389,
     271,   180,   272,   273,   475,   476,   490,   181,   491,   492,
     561,   274,   462,   463,   464,   465,   466,   467,   468,   182,
     833,   833,   833,   884,   885,   886,   183,   469,   184,   470,
     865,   865,   865,   471,   472,   185,   186,   473,   474,   236,
     237,   187,   477,   188,   478,   238,   475,   476,   661,   479,
     189,   268,   561,   568,   462,   463,   464,   465,   466,   467,
     468,   272,   273,   757,   190,   191,   192,   193,   480,   469,
     274,   470,   236,   237,   194,   471,   472,   199,   238,   473,
     474,   719,   478,   200,   477,   201,   478,   202,   475,   476,
     203,   479,   204,   292,   561,   571,   462,   463,   464,   465,
     466,   467,   468,   236,   237,   205,   480,   206,   207,   238,
     480,   469,   856,   470,   236,   237,   346,   471,   472,   293,
     238,   473,   474,   444,   478,   294,   477,   295,   478,   475,
     476,   530,   296,   479,   297,   404,   561,   572,   462,   463,
     464,   465,   466,   467,   468,   405,   406,   407,   480,   421,
     442,   443,   480,   469,   445,   470,   236,   237,   272,   471,
     472,   448,   238,   473,   474,   794,   478,   477,   457,   478,
     -35,   475,   476,   456,   479,   458,   450,   561,   573,   462,
     463,   464,   465,   466,   467,   468,   460,   454,   459,   461,
     480,   517,   520,   480,   469,   521,   470,   522,   523,   524,
     471,   472,   525,   526,   473,   474,   527,   560,   528,   477,
     529,   478,   576,   475,   476,   539,   479,   540,   566,   561,
     751,   462,   463,   464,   465,   466,   467,   468,   541,   542,
     543,   544,   545,   546,   577,   480,   469,   574,   470,   567,
     569,   570,   471,   472,   578,   575,   473,   474,   581,   582,
     592,   477,   585,   478,   515,   475,   476,   623,   479,   625,
     586,   561,   808,   462,   463,   464,   465,   466,   467,   468,
     591,   606,   627,   637,   638,   647,   648,   480,   469,   649,
     470,   650,   651,   652,   471,   472,   658,   663,   473,   474,
     670,   692,   705,   477,   693,   478,   475,   476,   694,   695,
     479,   696,   697,   561,   809,   462,   463,   464,   465,   466,
     467,   468,   698,   699,   715,   703,   740,   718,   744,   480,
     469,   745,   470,   747,   749,   755,   471,   472,   763,   764,
     473,   474,   773,   787,   477,   812,   478,   814,   475,   476,
     816,   479,   824,   817,   561,   810,   462,   463,   464,   465,
     466,   467,   468,   818,   819,   825,   829,   830,   834,   848,
     480,   469,   837,   470,   840,   849,   858,   471,   472,   867,
     868,   473,   474,   878,   870,   889,   477,   882,   478,   874,
     475,   476,   875,   479,   876,   879,   881,   811,   462,   463,
     464,   465,   466,   467,   468,   883,   888,   890,   891,   892,
     894,   893,   480,   469,   895,   236,   237,   896,   899,   898,
     900,   238,   901,   473,   474,   478,   903,   902,   477,   905,
     478,   607,   475,   476,   904,   479,   906,   210,   907,   813,
     462,   463,   464,   465,   466,   467,   468,   908,   909,   480,
     675,   455,   267,   584,   480,   774,   746,   470,   855,   748,
     775,   471,   472,   449,   860,   473,   474,   791,   629,     0,
     477,     0,   478,   475,   476,     0,     0,   479,     0,     0,
       0,   854,   462,   463,   464,   465,   466,   467,   468,     0,
       0,     0,     0,   724,     0,   725,   480,   774,     0,   470,
       0,     0,   775,   471,   472,     0,     0,   473,   474,     0,
       0,   477,     0,   478,     0,   475,   476,     0,   479,     0,
       0,     0,   869,   726,   727,   728,   729,   730,   731,   732,
     733,   734,     0,     0,     0,     0,     0,   480,     0,     0,
       0,     0,     0,     0,   797,   236,   237,     0,     0,   593,
     735,   238,     0,   477,     0,   478,     0,   475,   476,     0,
       0,     0,   594,   595,     0,   596,   462,   463,   464,   465,
     466,   467,   468,     0,     0,     0,     0,     0,     0,   480,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   807,
       0,   473,   474,     0,     0,   477,     0,   478,     0,   475,
     476,     0,   776,     0,     0,   777,     0,   462,   463,   464,
     465,   466,   467,   468,     0,     0,     0,     0,     0,     0,
       0,   480,   469,     0,   470,     0,     0,     0,   471,   472,
       0,     0,   473,   474,     0,     0,     0,   477,     0,   478,
       0,     0,     0,     0,   776,     0,     0,     0,   831,   462,
     463,   464,   465,   466,   467,   468,     0,     0,     0,     0,
       0,     0,     0,   480,   469,     0,   470,     0,     0,     0,
     471,   472,     0,     0,   473,   474,   462,   463,   464,   465,
     466,   467,   468,   475,   476,     0,     0,     0,     0,     0,
       0,   469,     0,   470,     0,     0,     0,   471,   472,   503,
       0,   473,   474,     0,     0,   389,   271,     0,   272,   273,
       0,     0,     0,   236,   237,     0,     0,   274,   639,   238,
       0,   477,   640,   478,   475,   476,     0,     0,     0,     0,
     641,   462,   463,   464,   465,   466,   467,   468,   679,   680,
     681,   682,   683,   684,   685,   686,   774,   480,   470,     0,
       0,   775,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,   477,     0,   478,     0,   475,   476,     0,   479,
       0,     0,     0,   673,   462,   463,   464,   465,   466,   467,
     468,     0,     0,     0,     0,     0,     0,     0,   480,   469,
       0,   470,     0,   475,   476,   471,   472,     0,     0,   473,
     474,     0,     0,     0,   477,     0,   478,     0,     0,     0,
       0,   479,     0,     0,   770,     0,     0,   726,   727,   728,
     729,   730,   731,   732,   733,   734,     0,     0,     0,     0,
     480,   477,     0,   478,     0,     0,     0,     0,   479,     0,
       0,     0,   822,   752,   735,     0,     0,     0,   475,   476,
       0,     0,     0,     0,     0,     0,     0,   480,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   549,   679,   680,
     681,   682,   683,   684,   685,   686,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   735,   477,   549,   478,     0,
       0,   475,   476,   776,     0,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,     0,     0,     0,     0,     0,
       0,     0,   480,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   477,
       0,   478,    -2,   209,     0,     0,   479,     0,     0,     0,
       0,    -8,   -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,
       0,     0,     0,     0,     0,   480,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,     0,    16,    17,    18,
      19,    20,     0,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     0,     0,     0,    89,    90,    91,     0,     0,     0,
       0,     0,     1,     0,     0,     0,     0,     0,     0,     0,
      -8,   -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,    18,    19,
      20,    92,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       0,     0,     0,    89,    90,    91,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      92
};

static const yytype_int16 yycheck[] =
{
     111,   125,   428,   465,   528,   116,   577,   433,   539,   435,
     541,   437,     1,     1,   585,   539,   528,   541,   188,   528,
       1,     1,     1,     1,     1,   528,     1,   539,     1,   541,
     539,     1,   541,   747,     1,   559,   539,   483,   541,     1,
     151,   152,   426,     1,   447,   429,     1,   431,   151,   495,
       1,   687,   498,   499,   500,   439,   125,   441,     1,   837,
     704,     1,   593,   594,   125,   164,   528,   166,   530,   593,
     594,     1,   596,     1,   160,   178,   538,   539,   540,   541,
     542,   593,   594,     1,   593,   594,   548,   658,   156,     1,
     593,   594,     1,   159,   160,   125,     1,   559,   184,   877,
     814,   158,     1,     1,   125,     1,   143,   144,   511,   154,
       1,   747,     1,   181,   892,   639,   125,   641,   184,     1,
     544,   159,   167,     1,   181,   159,   160,   164,   166,     1,
     125,   593,   594,   777,   596,   159,   143,   144,   125,     1,
     164,   125,   166,     1,     1,   676,   677,     1,   125,     1,
     184,   125,   676,   677,   538,     0,   280,     1,     1,   166,
       1,    21,    22,     1,   676,   677,     1,   676,   677,   595,
     632,     1,     1,   676,   677,   156,     1,   639,   814,   641,
     704,   170,   170,   158,   159,   165,   161,   162,   832,   168,
     168,   170,   170,   837,   164,   170,   158,   170,   165,   169,
     181,   704,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   170,   168,   676,   677,   156,   168,   158,   159,
     160,   647,   648,   649,   650,   168,   652,     1,   674,   691,
     874,   875,   876,   877,     1,     1,     1,   167,   700,   167,
     884,   885,   886,   705,   184,   150,   151,   159,   892,   167,
     159,   156,   714,   777,   159,   160,   702,   156,   156,   164,
     722,   166,   704,   159,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   777,   445,   167,   848,   167,   184,
     450,   159,   181,   181,   454,   167,   710,   159,   150,   151,
     736,   737,   738,   739,   156,   741,   704,   159,   829,   870,
     158,   159,   159,     1,   158,   829,   158,   159,   832,   150,
     151,   125,   156,   837,   158,   156,   159,   829,   159,   160,
     829,   159,    27,   164,   159,   166,   829,   125,   158,   832,
     159,   715,   716,   158,   837,   777,   506,   125,     1,     1,
       1,     1,   159,   184,   770,     1,     1,   125,     1,   166,
     874,   875,   876,   877,   465,     1,     1,   125,   820,   125,
     884,   885,   886,     1,     1,     1,   125,   829,   892,   777,
       1,   874,   875,   876,   877,     1,   125,   823,   824,   188,
     189,   884,   885,   886,   158,   159,   812,     1,     1,   892,
     832,   156,   159,   158,   159,   837,   161,   162,   143,   144,
     846,     1,     1,     1,     1,   170,     1,     1,     1,     1,
     125,   159,     1,   159,     1,   125,   181,   528,   166,   530,
     166,   166,     1,   534,   832,     1,     1,     1,   539,   837,
     541,     1,   874,   875,   876,   877,   125,   548,     1,     1,
     143,   144,   884,   885,   886,     1,     1,     1,   125,   125,
     892,     1,     1,     1,   159,   160,   161,   162,   163,     1,
       1,   159,   125,   166,   588,   170,   874,   875,   876,   877,
       1,     1,   164,     1,   166,   586,   884,   885,   886,   184,
       1,     1,   593,   594,   892,     1,     1,     3,     4,     5,
       6,     7,     8,     9,   156,   156,   158,   158,   158,   125,
     156,   156,    18,   156,    20,    21,    22,    23,    24,    25,
     156,   156,    28,    29,   150,   151,   125,     1,   156,   156,
     156,   632,     1,     1,     1,   156,     1,     1,     1,     3,
       4,     5,     6,     7,     8,     9,   150,   151,     1,   663,
     125,    27,   156,   156,    18,     1,    20,    21,    22,    23,
      24,    25,   150,   151,    28,    29,   156,   156,   156,   156,
       1,   156,   156,   156,   156,   676,   677,   156,     1,   156,
       3,     4,     5,     6,     7,     8,     9,   156,     1,   690,
     156,   156,   156,   125,   125,    18,   156,    20,    27,   700,
      23,    24,    25,   156,   156,    28,    29,     9,     1,     1,
     156,   156,   156,   714,   120,   121,   156,   156,   156,     1,
       1,   722,     3,     4,     5,     6,     7,     8,     9,   125,
       1,     1,   125,    50,   125,   156,   156,    18,   156,    20,
     125,     1,    23,    24,    25,   156,   156,    28,    29,    10,
     125,   156,   158,   125,   160,   125,   120,   121,   125,   165,
      11,    13,     1,   169,     3,     4,     5,     6,     7,     8,
       9,   125,   143,   144,   150,   151,    50,    12,   184,    18,
     156,    20,   156,   159,   160,    24,    25,   156,   156,    28,
      29,   156,   125,   156,   158,   166,   160,   120,   121,   159,
     125,   165,   164,   156,   166,   169,   166,   125,   184,   156,
     156,   158,   159,   125,   161,   162,   164,    50,   166,   820,
     184,   150,   151,   170,   825,   156,   125,   156,   829,   125,
     159,   160,    15,   125,   181,   158,   164,   160,   166,   120,
     121,   125,   165,   156,    16,     1,   169,     3,     4,     5,
       6,     7,     8,     9,    14,   184,   173,   174,   175,   125,
     125,   184,    18,   156,    20,   182,   183,   125,    24,    25,
     150,   151,    28,    29,   156,   125,   156,   158,   164,   160,
     166,   120,   121,   777,   165,   156,   156,     1,   169,     3,
       4,     5,     6,     7,     8,     9,   156,    17,   125,   173,
     174,   175,   125,   184,    18,   280,    20,   125,   182,   183,
      24,    25,   125,   125,    28,    29,   164,   125,   166,   158,
     125,   160,   150,   151,   152,   153,   165,   125,   125,     1,
     169,     3,     4,     5,     6,     7,     8,     9,   832,   125,
     173,   174,   175,   125,   172,   184,    18,   125,    20,   182,
     183,   125,    24,    25,   125,   125,    28,    29,   125,   158,
     159,   125,   161,   162,   120,   121,   156,   125,   158,   159,
       1,   170,     3,     4,     5,     6,     7,     8,     9,   125,
     874,   875,   876,   874,   875,   876,   125,    18,   125,    20,
     884,   885,   886,    24,    25,   125,   125,    28,    29,   150,
     151,   125,   158,   125,   160,   156,   120,   121,   159,   165,
     125,   159,     1,   169,     3,     4,     5,     6,     7,     8,
       9,   161,   162,   163,   125,   125,   125,   125,   184,    18,
     170,    20,   150,   151,   125,    24,    25,   125,   156,    28,
      29,   159,   160,   125,   158,   125,   160,   125,   120,   121,
     125,   165,   125,   156,     1,   169,     3,     4,     5,     6,
       7,     8,     9,   150,   151,   125,   184,   125,   125,   156,
     184,    18,   159,    20,   150,   151,   159,    24,    25,   156,
     156,    28,    29,     1,   160,   156,   158,   156,   160,   120,
     121,   167,   156,   165,   156,   156,     1,   169,     3,     4,
       5,     6,     7,     8,     9,   156,   158,   156,   184,   156,
     156,   156,   184,    18,   180,    20,   150,   151,   161,    24,
      25,   180,   156,    28,    29,   159,   160,   158,   164,   160,
     180,   120,   121,   175,   165,   175,   180,     1,   169,     3,
       4,     5,     6,     7,     8,     9,   185,   180,   180,   175,
     184,   171,   158,   184,    18,   158,    20,   159,   158,   168,
      24,    25,   156,   158,    28,    29,   167,   165,   167,   158,
     167,   160,   180,   120,   121,   167,   165,   167,   171,     1,
     169,     3,     4,     5,     6,     7,     8,     9,   167,   167,
     167,   167,   167,   167,   180,   184,    18,   164,    20,   171,
     171,   171,    24,    25,   158,   171,    28,    29,   156,   158,
     166,   158,   180,   160,   159,   120,   121,   159,   165,   159,
     164,     1,   169,     3,     4,     5,     6,     7,     8,     9,
     187,   166,   158,    27,    27,   168,   168,   184,    18,   168,
      20,   168,   156,   168,    24,    25,   180,   167,    28,    29,
     156,   166,    26,   158,   166,   160,   120,   121,   166,   166,
     165,   164,   166,     1,   169,     3,     4,     5,     6,     7,
       8,     9,   164,   166,   164,   166,   171,   166,   166,   184,
      18,   166,    20,   164,   153,   159,    24,    25,   159,   159,
      28,    29,   168,   159,   158,   168,   160,   164,   120,   121,
      25,   165,    19,   166,     1,   169,     3,     4,     5,     6,
       7,     8,     9,   166,   166,    21,   167,   165,   165,   164,
     184,    18,   166,    20,   166,   156,   169,    24,    25,   156,
     159,    28,    29,   166,   164,   159,   158,   186,   160,   180,
     120,   121,   180,   165,   180,   166,   164,   169,     3,     4,
       5,     6,     7,     8,     9,   156,   164,   156,   186,    19,
     166,   159,   184,    18,   187,   150,   151,   156,   156,   166,
     187,   156,   153,    28,    29,   160,    25,   156,   158,   156,
     160,   166,   120,   121,   153,   165,    25,    94,   188,   169,
       3,     4,     5,     6,     7,     8,     9,   156,   188,   184,
     596,   280,   123,   515,   184,    18,   663,    20,   824,   668,
      23,    24,    25,   274,   827,    28,    29,   714,   546,    -1,
     158,    -1,   160,   120,   121,    -1,    -1,   165,    -1,    -1,
      -1,   169,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,   639,    -1,   641,   184,    18,    -1,    20,
      -1,    -1,    23,    24,    25,    -1,    -1,    28,    29,    -1,
      -1,   158,    -1,   160,    -1,   120,   121,    -1,   165,    -1,
      -1,    -1,   169,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,    -1,    -1,    -1,    -1,   184,    -1,    -1,
      -1,    -1,    -1,    -1,   166,   150,   151,    -1,    -1,   154,
     172,   156,    -1,   158,    -1,   160,    -1,   120,   121,    -1,
      -1,    -1,   167,   168,    -1,   170,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,   184,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
      -1,    28,    29,    -1,    -1,   158,    -1,   160,    -1,   120,
     121,    -1,   165,    -1,    -1,   168,    -1,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   184,    18,    -1,    20,    -1,    -1,    -1,    24,    25,
      -1,    -1,    28,    29,    -1,    -1,    -1,   158,    -1,   160,
      -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,   169,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   184,    18,    -1,    20,    -1,    -1,    -1,
      24,    25,    -1,    -1,    28,    29,     3,     4,     5,     6,
       7,     8,     9,   120,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,   152,
      -1,    28,    29,    -1,    -1,   158,   159,    -1,   161,   162,
      -1,    -1,    -1,   150,   151,    -1,    -1,   170,   155,   156,
      -1,   158,   159,   160,   120,   121,    -1,    -1,    -1,    -1,
     167,     3,     4,     5,     6,     7,     8,     9,   126,   127,
     128,   129,   130,   131,   132,   133,    18,   184,    20,    -1,
      -1,    23,    24,    25,    -1,    -1,    28,    29,    -1,    -1,
      -1,    -1,   158,    -1,   160,    -1,   120,   121,    -1,   165,
      -1,    -1,    -1,   169,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,    18,
      -1,    20,    -1,   120,   121,    24,    25,    -1,    -1,    28,
      29,    -1,    -1,    -1,   158,    -1,   160,    -1,    -1,    -1,
      -1,   165,    -1,    -1,   168,    -1,    -1,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,    -1,    -1,    -1,
     184,   158,    -1,   160,    -1,    -1,    -1,    -1,   165,    -1,
      -1,    -1,   169,   171,   172,    -1,    -1,    -1,   120,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   172,   158,   125,   160,    -1,
      -1,   120,   121,   165,    -1,    -1,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,
      -1,   160,     0,     1,    -1,    -1,   165,    -1,    -1,    -1,
      -1,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      -1,    -1,    -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    -1,    45,    46,    47,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    -1,    45,    46,    47,    48,
      49,   179,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    45,    46,    47,    48,
      49,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   122,
     123,   124,   179,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   225,   226,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,     1,
     125,     1,   125,     1,   125,     1,   125,     1,   125,     1,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,     1,   159,   125,     1,   167,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,     1,   125,     1,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,     0,     1,
     194,     9,   235,    10,   236,    11,   237,    12,   238,    13,
     239,    14,   240,    15,   241,    16,   242,    17,   243,     1,
     156,     1,   156,     1,   156,     1,   150,   151,   156,   209,
       1,   156,     1,   156,     1,   156,     1,   156,   209,     1,
     159,     1,   156,     1,   156,     1,   158,     1,   159,     1,
     156,   158,   207,   210,   211,   217,     1,   217,   159,     1,
     158,   159,   161,   162,   170,   181,   204,   206,   207,   210,
     212,   213,   227,   228,   229,   230,     1,   156,     1,   156,
       1,   156,   156,   156,   156,   156,   156,   156,     1,   156,
       1,   156,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   159,     1,   156,     1,   159,     1,   156,     1,   209,
       1,   209,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   156,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   159,     1,   159,     1,   159,   159,     1,   156,     1,
     158,   159,     1,   158,   159,     1,   156,     1,   158,   159,
       1,   156,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   156,     1,   158,     1,   158,     1,   156,     1,   156,
       1,   156,     1,   156,     1,   156,     1,   156,     1,   158,
     204,     1,   156,     1,   156,     1,   156,     1,   156,     1,
     156,     1,   156,   158,   156,   156,   158,   156,     1,   159,
       1,   159,     1,   156,     1,   156,     1,   158,   224,     1,
     156,   156,     1,   168,   170,     1,   170,     1,   168,   170,
       1,   170,     1,   168,     1,   168,     1,   168,     1,   170,
       1,   170,   156,   156,     1,   180,   219,   218,   180,   229,
     180,   151,   178,   205,   180,   213,   175,   164,   175,   180,
     185,   175,     3,     4,     5,     6,     7,     8,     9,    18,
      20,    24,    25,    28,    29,   120,   121,   158,   160,   165,
     184,   250,   255,   259,   261,   264,   265,   266,   267,   275,
     156,   158,   159,   233,   233,   259,   233,   233,   259,   259,
     259,   233,   233,   152,   204,    50,   173,   174,   175,   182,
     183,   215,   216,   216,     1,   159,   221,   171,   204,     1,
     158,   158,   159,   158,   168,   156,   158,   167,   167,   167,
     167,   209,   250,     1,   167,     1,   167,     1,   167,   167,
     167,   167,   167,   167,   167,   167,   167,     1,   167,   125,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   253,
     165,     1,   169,   261,     1,   165,   171,   171,   169,   171,
     171,   169,   169,   169,   164,   171,   180,   180,   158,   204,
     214,   156,   158,   216,   221,   180,   164,   154,   167,   222,
     223,   187,   166,   154,   167,   168,   170,   209,   244,   250,
     251,   252,   255,   256,   264,   275,   166,   166,   209,   250,
       1,   159,   209,     1,   159,     1,   233,   234,   250,   244,
     250,   244,   250,   159,   232,   159,   232,   158,   274,   274,
       1,   159,   164,   166,   209,   250,   272,    27,    27,   155,
     159,   167,   209,   250,   252,   254,   275,   168,   168,   168,
     168,   156,   168,   156,   181,   208,     1,   208,   180,     1,
     208,   159,   209,   167,   181,   207,   220,     1,   164,   169,
     156,   244,   244,   169,   259,   254,   143,   144,   164,   126,
     127,   128,   129,   130,   131,   132,   133,   245,   246,   247,
     248,   249,   166,   166,   166,   166,   164,   166,   164,   166,
     164,   166,   166,   166,   166,    26,   159,   166,   159,   166,
     164,   166,   166,     1,   167,   164,   164,   166,   166,   159,
     209,   250,   164,   166,   254,   254,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   172,   259,   259,   259,   259,
     171,   259,     1,   208,   166,   166,   220,   164,   222,   153,
     166,   169,   171,   244,   244,   159,    27,   163,   227,   231,
     209,   159,   250,   159,   159,    27,   159,   209,   250,   273,
     168,   258,   261,   168,    18,    23,   165,   168,   255,   257,
     262,   263,   265,   266,   267,   275,   250,   159,   232,     1,
     166,   272,   233,   233,   159,   209,   250,   166,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   169,   169,
     169,   169,   168,   169,   164,   231,    25,   166,   166,   166,
     164,   166,   169,   259,    19,    21,   268,   269,   270,   167,
     165,   169,   260,   262,   165,     1,   165,   166,   166,   166,
     166,   166,   164,   166,   164,   166,   259,   231,   164,   156,
      27,   159,   209,   250,   169,   258,   159,   209,   169,    22,
     270,   271,   244,     1,   169,   262,   257,   156,   159,   169,
     164,   208,   188,   189,   180,   180,   180,   166,   166,   166,
     208,   164,   186,   156,   260,   260,   260,   257,   164,   159,
     156,   186,    19,   159,   166,   187,   156,   257,   166,   156,
     187,   153,   156,    25,   153,   156,    25,   188,   156,   188
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   191,   192,   193,   193,   193,   194,   194,   195,   194,
     196,   194,   197,   194,   198,   194,   199,   194,   200,   194,
     201,   194,   202,   194,   203,   194,   194,   204,   204,   204,
     205,   205,   206,   206,   206,   207,   208,   208,   209,   209,
     209,   210,   210,   210,   210,   211,   211,   212,   212,   212,
     212,   212,   213,   213,   214,   214,   214,   215,   215,   215,
     215,   215,   215,   216,   216,   217,   217,   218,   217,   219,
     217,   220,   220,   221,   221,   222,   222,   223,   223,   223,
     224,   224,   224,   224,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   226,   226,   226,   226,   226,   227,
     227,   228,   229,   230,   230,   231,   231,   232,   232,   233,
     233,   233,   234,   234,   235,   235,   235,   236,   236,   237,
     237,   237,   238,   238,   239,   239,   240,   240,   241,   241,
     242,   242,   243,   243,   244,   244,   244,   244,   244,   244,
     245,   245,   246,   246,   246,   246,   247,   247,   248,   248,
     249,   249,   249,   250,   250,   251,   251,   251,   251,   252,
     252,   252,   252,   252,   253,   253,   253,   253,   253,   253,
     253,   253,   253,   253,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   255,   255,   255,   256,   256,   256,   256,   256,   257,
     257,   257,   258,   258,   258,   259,   259,   259,   260,   260,
     260,   261,   261,   261,   261,   261,   261,   261,   261,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   263,   263,
     264,   264,   265,   266,   267,   268,   268,   269,   269,   270,
     270,   270,   270,   271,   271,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   273,   273,   273,   273,
     273,   273,   273,   273,   274,   274,   274,   274,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     1,     2,
       2,     2,     2,     1,     2,     1,     1,     0,     3,     0,
       3,     1,     1,     1,     2,     9,    10,     3,     1,     2,
      18,    17,    10,     9,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     3,
       3,     3,     5,     3,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     2,     7,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     8,     8,     2,     1,
       1,     1,     1,     1,     3,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     4,     7,     2,     7,     2,     4,
       7,     2,     7,     2,     4,     2,     4,     2,     4,     2,
       9,     2,     7,     2,     3,     3,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     1,     1,     1,     3,     2,     1,
       3,     2,     1,     3,     2,     2,     1,     2,     2,     1,
       2,     2,     1,     1,     1,     1,     2,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     1,     2,     5,     7,
       5,     7,     5,     7,     7,     2,     1,     2,     1,     4,
       3,     4,     3,     3,     2,     1,     3,     1,     2,     2,
       1,     2,     3,     1,     2,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     4,     4,     2,     6,     1,
       3,     1,     3,     2,     4,     2,     4,     3,     1,     4,
       6,     2,     4,     6,     2,     4,     4,     6,     2,     4,
       3,     4,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     8,     8,     6,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 486 "cfg.y"
                                     {}
#line 2387 "cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 487 "cfg.y"
                            {}
#line 2393 "cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 488 "cfg.y"
                                   { yyerror(""); YYABORT;}
#line 2399 "cfg.tab.c"
    break;

  case 8: /* $@1: %empty  */
#line 493 "cfg.y"
                  {rt=REQUEST_ROUTE;}
#line 2405 "cfg.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 494 "cfg.y"
                  {rt=FAILURE_ROUTE;}
#line 2411 "cfg.tab.c"
    break;

  case 12: /* $@3: %empty  */
#line 495 "cfg.y"
                  {rt=ONREPLY_ROUTE;}
#line 2417 "cfg.tab.c"
    break;

  case 14: /* $@4: %empty  */
#line 496 "cfg.y"
                  {rt=BRANCH_ROUTE;}
#line 2423 "cfg.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 497 "cfg.y"
                  {rt=ERROR_ROUTE;}
#line 2429 "cfg.tab.c"
    break;

  case 18: /* $@6: %empty  */
#line 498 "cfg.y"
                  {rt=LOCAL_ROUTE;}
#line 2435 "cfg.tab.c"
    break;

  case 20: /* $@7: %empty  */
#line 499 "cfg.y"
                  {rt=STARTUP_ROUTE;}
#line 2441 "cfg.tab.c"
    break;

  case 22: /* $@8: %empty  */
#line 500 "cfg.y"
                  {rt=TIMER_ROUTE;}
#line 2447 "cfg.tab.c"
    break;

  case 24: /* $@9: %empty  */
#line 501 "cfg.y"
                  {rt=EVENT_ROUTE;}
#line 2453 "cfg.tab.c"
    break;

  case 27: /* listen_id: ip  */
#line 506 "cfg.y"
                                        { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2473 "cfg.tab.c"
    break;

  case 28: /* listen_id: STRING  */
#line 521 "cfg.y"
                                        { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2487 "cfg.tab.c"
    break;

  case 29: /* listen_id: host  */
#line 530 "cfg.y"
                                        { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2505 "cfg.tab.c"
    break;

  case 30: /* host_sep: DOT  */
#line 545 "cfg.y"
                    {(yyval.strval)=".";}
#line 2511 "cfg.tab.c"
    break;

  case 31: /* host_sep: MINUS  */
#line 546 "cfg.y"
                              {(yyval.strval)="-"; }
#line 2517 "cfg.tab.c"
    break;

  case 32: /* host: ID  */
#line 549 "cfg.y"
                                        { (yyval.strval)=(yyvsp[0].strval); }
#line 2523 "cfg.tab.c"
    break;

  case 33: /* host: host host_sep ID  */
#line 550 "cfg.y"
                                { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2542 "cfg.tab.c"
    break;

  case 34: /* host: host DOT error  */
#line 564 "cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2550 "cfg.tab.c"
    break;

  case 35: /* proto: ID  */
#line 569 "cfg.y"
           { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2563 "cfg.tab.c"
    break;

  case 36: /* port: NUMBER  */
#line 579 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2569 "cfg.tab.c"
    break;

  case 37: /* port: ANY  */
#line 580 "cfg.y"
                                { (yyval.intval)=0; }
#line 2575 "cfg.tab.c"
    break;

  case 38: /* snumber: NUMBER  */
#line 583 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2581 "cfg.tab.c"
    break;

  case 39: /* snumber: PLUS NUMBER  */
#line 584 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2587 "cfg.tab.c"
    break;

  case 40: /* snumber: MINUS NUMBER  */
#line 585 "cfg.y"
                                { (yyval.intval)=-(yyvsp[0].intval); }
#line 2593 "cfg.tab.c"
    break;

  case 41: /* phostport: proto COLON listen_id  */
#line 589 "cfg.y"
                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2600 "cfg.tab.c"
    break;

  case 42: /* phostport: proto COLON listen_id COLON port  */
#line 591 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2607 "cfg.tab.c"
    break;

  case 43: /* phostport: proto COLON listen_id COLON error  */
#line 593 "cfg.y"
                                                            {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2617 "cfg.tab.c"
    break;

  case 44: /* phostport: NUMBER error  */
#line 598 "cfg.y"
                                       { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2626 "cfg.tab.c"
    break;

  case 45: /* panyhostport: proto COLON MULT  */
#line 604 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2633 "cfg.tab.c"
    break;

  case 46: /* panyhostport: proto COLON MULT COLON port  */
#line 606 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2640 "cfg.tab.c"
    break;

  case 47: /* alias_def: listen_id  */
#line 610 "cfg.y"
                                                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2647 "cfg.tab.c"
    break;

  case 48: /* alias_def: ANY COLON listen_id  */
#line 612 "cfg.y"
                                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2654 "cfg.tab.c"
    break;

  case 49: /* alias_def: ANY COLON listen_id COLON port  */
#line 614 "cfg.y"
                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2661 "cfg.tab.c"
    break;

  case 50: /* alias_def: ANY COLON listen_id COLON error  */
#line 616 "cfg.y"
                                                        {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2670 "cfg.tab.c"
    break;

  case 52: /* id_lst: alias_def  */
#line 623 "cfg.y"
                                        { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2676 "cfg.tab.c"
    break;

  case 53: /* id_lst: alias_def id_lst  */
#line 624 "cfg.y"
                                        { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2682 "cfg.tab.c"
    break;

  case 54: /* listen_id_def: listen_id  */
#line 627 "cfg.y"
                                                                { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2689 "cfg.tab.c"
    break;

  case 55: /* listen_id_def: listen_id COLON port  */
#line 629 "cfg.y"
                                                                { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2696 "cfg.tab.c"
    break;

  case 56: /* listen_id_def: listen_id COLON error  */
#line 631 "cfg.y"
                                                      {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2705 "cfg.tab.c"
    break;

  case 57: /* socket_def_param: ANYCAST  */
#line 637 "cfg.y"
                          { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2713 "cfg.tab.c"
    break;

  case 58: /* socket_def_param: FRAG  */
#line 640 "cfg.y"
                                       { IFOR();
					p_tmp.flags |= SI_FRAG;
					}
#line 2721 "cfg.tab.c"
    break;

  case 59: /* socket_def_param: USE_WORKERS NUMBER  */
#line 643 "cfg.y"
                                                     { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2729 "cfg.tab.c"
    break;

  case 60: /* socket_def_param: AS listen_id_def  */
#line 646 "cfg.y"
                                                   { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2737 "cfg.tab.c"
    break;

  case 61: /* socket_def_param: TAG ID  */
#line 649 "cfg.y"
                                         { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2745 "cfg.tab.c"
    break;

  case 62: /* socket_def_param: USE_AUTO_SCALING_PROFILE ID  */
#line 652 "cfg.y"
                                                              { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2753 "cfg.tab.c"
    break;

  case 65: /* socket_def: panyhostport  */
#line 661 "cfg.y"
                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2759 "cfg.tab.c"
    break;

  case 66: /* socket_def: phostport  */
#line 662 "cfg.y"
                                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2765 "cfg.tab.c"
    break;

  case 67: /* $@10: %empty  */
#line 663 "cfg.y"
                                       { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2773 "cfg.tab.c"
    break;

  case 68: /* socket_def: panyhostport $@10 socket_def_params  */
#line 665 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2781 "cfg.tab.c"
    break;

  case 69: /* $@11: %empty  */
#line 668 "cfg.y"
                                    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2789 "cfg.tab.c"
    break;

  case 70: /* socket_def: phostport $@11 socket_def_params  */
#line 670 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2797 "cfg.tab.c"
    break;

  case 71: /* any_proto: ANY  */
#line 675 "cfg.y"
                        { (yyval.intval)=PROTO_NONE; }
#line 2803 "cfg.tab.c"
    break;

  case 72: /* any_proto: proto  */
#line 676 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2809 "cfg.tab.c"
    break;

  case 73: /* multi_string: STRING  */
#line 678 "cfg.y"
                       {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2815 "cfg.tab.c"
    break;

  case 74: /* multi_string: STRING multi_string  */
#line 679 "cfg.y"
                                      { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2821 "cfg.tab.c"
    break;

  case 75: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 682 "cfg.y"
                                                                        {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2834 "cfg.tab.c"
    break;

  case 76: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 690 "cfg.y"
                                                                                    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2848 "cfg.tab.c"
    break;

  case 77: /* blst_elem_list: blst_elem_list COMMA blst_elem  */
#line 701 "cfg.y"
                                               {}
#line 2854 "cfg.tab.c"
    break;

  case 78: /* blst_elem_list: blst_elem  */
#line 702 "cfg.y"
                            {}
#line 2860 "cfg.tab.c"
    break;

  case 79: /* blst_elem_list: blst_elem_list error  */
#line 703 "cfg.y"
                                       { yyerror("bad black list element");}
#line 2866 "cfg.tab.c"
    break;

  case 80: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 710 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2876 "cfg.tab.c"
    break;

  case 81: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 718 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2886 "cfg.tab.c"
    break;

  case 82: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER  */
#line 724 "cfg.y"
                                                            { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 2896 "cfg.tab.c"
    break;

  case 83: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 730 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 2906 "cfg.tab.c"
    break;

  case 84: /* assign_stm: LOGLEVEL EQUAL snumber  */
#line 737 "cfg.y"
                                   { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 2915 "cfg.tab.c"
    break;

  case 85: /* assign_stm: LOGPREFIX EQUAL STRING  */
#line 741 "cfg.y"
                                         { IFOR();
			if (*(yyvsp[0].strval)) {
				int len = strlen((yyvsp[0].strval));
				char *buf = pkg_malloc(len + 2);
				if (!buf)
					yyerror("oom");
				sprintf(buf, "%s:", (yyvsp[0].strval));
				log_prefix = buf;
			} else {
				log_prefix = (yyvsp[0].strval);
			}
			}
#line 2932 "cfg.tab.c"
    break;

  case 86: /* assign_stm: LOGPREFIX EQUAL error  */
#line 753 "cfg.y"
                                         { yyerror("string value expected"); }
#line 2938 "cfg.tab.c"
    break;

  case 87: /* assign_stm: ENABLE_ASSERTS EQUAL NUMBER  */
#line 754 "cfg.y"
                                               { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 2944 "cfg.tab.c"
    break;

  case 88: /* assign_stm: ENABLE_ASSERTS EQUAL error  */
#line 755 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 2950 "cfg.tab.c"
    break;

  case 89: /* assign_stm: ABORT_ON_ASSERT EQUAL NUMBER  */
#line 756 "cfg.y"
                                                { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 2956 "cfg.tab.c"
    break;

  case 90: /* assign_stm: ABORT_ON_ASSERT EQUAL error  */
#line 757 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 2962 "cfg.tab.c"
    break;

  case 91: /* assign_stm: DEBUG_MODE EQUAL NUMBER  */
#line 758 "cfg.y"
                                           { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 2971 "cfg.tab.c"
    break;

  case 92: /* assign_stm: DEBUG_MODE EQUAL error  */
#line 763 "cfg.y"
                        { yyerror("boolean value expected for debug_mode"); }
#line 2977 "cfg.tab.c"
    break;

  case 93: /* assign_stm: LOGSTDOUT EQUAL NUMBER  */
#line 766 "cfg.y"
                        { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 2983 "cfg.tab.c"
    break;

  case 94: /* assign_stm: LOGSTDOUT EQUAL error  */
#line 767 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 2989 "cfg.tab.c"
    break;

  case 95: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 771 "cfg.y"
                        { IFOR(); if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 2995 "cfg.tab.c"
    break;

  case 96: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 772 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 3001 "cfg.tab.c"
    break;

  case 97: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 773 "cfg.y"
                                       { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3012 "cfg.tab.c"
    break;

  case 98: /* assign_stm: LOGFACILITY EQUAL error  */
#line 779 "cfg.y"
                                          { yyerror("ID expected"); }
#line 3018 "cfg.tab.c"
    break;

  case 99: /* assign_stm: LOGNAME EQUAL STRING  */
#line 780 "cfg.y"
                                       { IFOR(); log_name=(yyvsp[0].strval); }
#line 3024 "cfg.tab.c"
    break;

  case 100: /* assign_stm: LOGNAME EQUAL error  */
#line 781 "cfg.y"
                                      { yyerror("string value expected"); }
#line 3030 "cfg.tab.c"
    break;

  case 101: /* assign_stm: DNS EQUAL NUMBER  */
#line 782 "cfg.y"
                                     { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3036 "cfg.tab.c"
    break;

  case 102: /* assign_stm: DNS EQUAL error  */
#line 783 "cfg.y"
                                  { yyerror("boolean value expected"); }
#line 3042 "cfg.tab.c"
    break;

  case 103: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 784 "cfg.y"
                                       { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3048 "cfg.tab.c"
    break;

  case 104: /* assign_stm: REV_DNS EQUAL error  */
#line 785 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3054 "cfg.tab.c"
    break;

  case 105: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 786 "cfg.y"
                                              { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3060 "cfg.tab.c"
    break;

  case 106: /* assign_stm: DNS_TRY_IPV6 error  */
#line 787 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3066 "cfg.tab.c"
    break;

  case 107: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 788 "cfg.y"
                                               { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3072 "cfg.tab.c"
    break;

  case 108: /* assign_stm: DNS_TRY_NAPTR error  */
#line 789 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3078 "cfg.tab.c"
    break;

  case 109: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 790 "cfg.y"
                                               { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3084 "cfg.tab.c"
    break;

  case 110: /* assign_stm: DNS_RETR_TIME error  */
#line 791 "cfg.y"
                                      { yyerror("number expected"); }
#line 3090 "cfg.tab.c"
    break;

  case 111: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 792 "cfg.y"
                                             { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3096 "cfg.tab.c"
    break;

  case 112: /* assign_stm: DNS_RETR_NO error  */
#line 793 "cfg.y"
                                    { yyerror("number expected"); }
#line 3102 "cfg.tab.c"
    break;

  case 113: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 794 "cfg.y"
                                                { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3108 "cfg.tab.c"
    break;

  case 114: /* assign_stm: DNS_SERVERS_NO error  */
#line 795 "cfg.y"
                                       { yyerror("number expected"); }
#line 3114 "cfg.tab.c"
    break;

  case 115: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 796 "cfg.y"
                                                { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3120 "cfg.tab.c"
    break;

  case 116: /* assign_stm: DNS_USE_SEARCH error  */
#line 797 "cfg.y"
                                       { yyerror("boolean value expected"); }
#line 3126 "cfg.tab.c"
    break;

  case 117: /* assign_stm: MAX_WHILE_LOOPS EQUAL NUMBER  */
#line 798 "cfg.y"
                                               { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3132 "cfg.tab.c"
    break;

  case 118: /* assign_stm: MAX_WHILE_LOOPS EQUAL error  */
#line 799 "cfg.y"
                                              { yyerror("number expected"); }
#line 3138 "cfg.tab.c"
    break;

  case 119: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 800 "cfg.y"
                                         { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3144 "cfg.tab.c"
    break;

  case 120: /* assign_stm: MAXBUFFER EQUAL error  */
#line 801 "cfg.y"
                                        { yyerror("number expected"); }
#line 3150 "cfg.tab.c"
    break;

  case 121: /* assign_stm: UDP_WORKERS EQUAL NUMBER  */
#line 802 "cfg.y"
                                           { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3156 "cfg.tab.c"
    break;

  case 122: /* assign_stm: UDP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 803 "cfg.y"
                                                                       { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3165 "cfg.tab.c"
    break;

  case 123: /* assign_stm: UDP_WORKERS EQUAL error  */
#line 807 "cfg.y"
                                          { yyerror("number expected"); }
#line 3171 "cfg.tab.c"
    break;

  case 124: /* assign_stm: TIMER_WORKERS EQUAL NUMBER  */
#line 808 "cfg.y"
                                             { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3179 "cfg.tab.c"
    break;

  case 125: /* assign_stm: TIMER_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 811 "cfg.y"
                                                                         { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3188 "cfg.tab.c"
    break;

  case 126: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 815 "cfg.y"
                                         { check_via=(yyvsp[0].intval); }
#line 3194 "cfg.tab.c"
    break;

  case 127: /* assign_stm: CHECK_VIA EQUAL error  */
#line 816 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3200 "cfg.tab.c"
    break;

  case 128: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL NUMBER  */
#line 817 "cfg.y"
                                                         { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3213 "cfg.tab.c"
    break;

  case 129: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL error  */
#line 825 "cfg.y"
                                                        {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3226 "cfg.tab.c"
    break;

  case 130: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL NUMBER  */
#line 833 "cfg.y"
                                                       { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3239 "cfg.tab.c"
    break;

  case 131: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL error  */
#line 841 "cfg.y"
                                                      {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3252 "cfg.tab.c"
    break;

  case 132: /* assign_stm: MEM_WARMING_ENABLED EQUAL NUMBER  */
#line 849 "cfg.y"
                                                   { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3265 "cfg.tab.c"
    break;

  case 133: /* assign_stm: MEM_WARMING_ENABLED EQUAL error  */
#line 857 "cfg.y"
                                                  {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3278 "cfg.tab.c"
    break;

  case 134: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL STRING  */
#line 865 "cfg.y"
                                                        { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3291 "cfg.tab.c"
    break;

  case 135: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL error  */
#line 873 "cfg.y"
                                                       {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3304 "cfg.tab.c"
    break;

  case 136: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL NUMBER  */
#line 881 "cfg.y"
                                                      { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3317 "cfg.tab.c"
    break;

  case 137: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL error  */
#line 889 "cfg.y"
                                                     {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3330 "cfg.tab.c"
    break;

  case 138: /* assign_stm: RPM_MEM_FILE EQUAL STRING  */
#line 897 "cfg.y"
                                            { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3338 "cfg.tab.c"
    break;

  case 139: /* assign_stm: RPM_MEM_FILE EQUAL error  */
#line 900 "cfg.y"
                                           { yyerror("string value expected"); }
#line 3344 "cfg.tab.c"
    break;

  case 140: /* assign_stm: RPM_MEM_SIZE EQUAL NUMBER  */
#line 901 "cfg.y"
                                            { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3352 "cfg.tab.c"
    break;

  case 141: /* assign_stm: RPM_MEM_SIZE EQUAL error  */
#line 904 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3358 "cfg.tab.c"
    break;

  case 142: /* assign_stm: MEMLOG EQUAL snumber  */
#line 905 "cfg.y"
                                       { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3364 "cfg.tab.c"
    break;

  case 143: /* assign_stm: MEMLOG EQUAL error  */
#line 906 "cfg.y"
                                     { yyerror("int value expected"); }
#line 3370 "cfg.tab.c"
    break;

  case 144: /* assign_stm: MEMDUMP EQUAL snumber  */
#line 907 "cfg.y"
                                        { IFOR(); memdump=(yyvsp[0].intval); }
#line 3376 "cfg.tab.c"
    break;

  case 145: /* assign_stm: MEMDUMP EQUAL error  */
#line 908 "cfg.y"
                                      { yyerror("int value expected"); }
#line 3382 "cfg.tab.c"
    break;

  case 146: /* assign_stm: EXECMSGTHRESHOLD EQUAL NUMBER  */
#line 909 "cfg.y"
                                                {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3388 "cfg.tab.c"
    break;

  case 147: /* assign_stm: EXECMSGTHRESHOLD EQUAL error  */
#line 910 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3394 "cfg.tab.c"
    break;

  case 148: /* assign_stm: EXECDNSTHRESHOLD EQUAL NUMBER  */
#line 911 "cfg.y"
                                                { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 3400 "cfg.tab.c"
    break;

  case 149: /* assign_stm: EXECDNSTHRESHOLD EQUAL error  */
#line 912 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3406 "cfg.tab.c"
    break;

  case 150: /* assign_stm: TCPTHRESHOLD EQUAL NUMBER  */
#line 913 "cfg.y"
                                            { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 3412 "cfg.tab.c"
    break;

  case 151: /* assign_stm: TCPTHRESHOLD EQUAL error  */
#line 914 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3418 "cfg.tab.c"
    break;

  case 152: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL NUMBER  */
#line 915 "cfg.y"
                                                   { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3433 "cfg.tab.c"
    break;

  case 153: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL error  */
#line 925 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3439 "cfg.tab.c"
    break;

  case 154: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL NUMBER  */
#line 926 "cfg.y"
                                                   { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 3458 "cfg.tab.c"
    break;

  case 155: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL error  */
#line 940 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3464 "cfg.tab.c"
    break;

  case 156: /* assign_stm: QUERYBUFFERSIZE EQUAL NUMBER  */
#line 941 "cfg.y"
                                               { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 3470 "cfg.tab.c"
    break;

  case 157: /* assign_stm: QUERYBUFFERSIZE EQUAL error  */
#line 942 "cfg.y"
                                              { yyerror("int value expected"); }
#line 3476 "cfg.tab.c"
    break;

  case 158: /* assign_stm: QUERYFLUSHTIME EQUAL NUMBER  */
#line 943 "cfg.y"
                                              { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 3482 "cfg.tab.c"
    break;

  case 159: /* assign_stm: QUERYFLUSHTIME EQUAL error  */
#line 944 "cfg.y"
                                             { yyerror("int value expected"); }
#line 3488 "cfg.tab.c"
    break;

  case 160: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 945 "cfg.y"
                                           { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 3494 "cfg.tab.c"
    break;

  case 161: /* assign_stm: SIP_WARNING EQUAL error  */
#line 946 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 3500 "cfg.tab.c"
    break;

  case 162: /* assign_stm: CHROOT EQUAL STRING  */
#line 947 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3506 "cfg.tab.c"
    break;

  case 163: /* assign_stm: CHROOT EQUAL ID  */
#line 948 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3512 "cfg.tab.c"
    break;

  case 164: /* assign_stm: CHROOT EQUAL error  */
#line 949 "cfg.y"
                                          { yyerror("string value expected"); }
#line 3518 "cfg.tab.c"
    break;

  case 165: /* assign_stm: WDIR EQUAL STRING  */
#line 950 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3524 "cfg.tab.c"
    break;

  case 166: /* assign_stm: WDIR EQUAL ID  */
#line 951 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3530 "cfg.tab.c"
    break;

  case 167: /* assign_stm: WDIR EQUAL error  */
#line 952 "cfg.y"
                                        { yyerror("string value expected"); }
#line 3536 "cfg.tab.c"
    break;

  case 168: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 953 "cfg.y"
                                      { IFOR(); mhomed=(yyvsp[0].intval); }
#line 3542 "cfg.tab.c"
    break;

  case 169: /* assign_stm: MHOMED EQUAL error  */
#line 954 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3548 "cfg.tab.c"
    break;

  case 170: /* assign_stm: POLL_METHOD EQUAL ID  */
#line 955 "cfg.y"
                                       { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 3563 "cfg.tab.c"
    break;

  case 171: /* assign_stm: POLL_METHOD EQUAL STRING  */
#line 965 "cfg.y"
                                           { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 3578 "cfg.tab.c"
    break;

  case 172: /* assign_stm: POLL_METHOD EQUAL error  */
#line 975 "cfg.y"
                                          { yyerror("poll method name expected"); }
#line 3584 "cfg.tab.c"
    break;

  case 173: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 976 "cfg.y"
                                                  { IFOR();
				if ((yyvsp[0].intval) < TCP_ALIAS_NEVER || (yyvsp[0].intval) > TCP_ALIAS_ALWAYS)
					yyerror("invalid 'tcp_accept_aliases' value");
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 3594 "cfg.tab.c"
    break;

  case 174: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 981 "cfg.y"
                                                 { yyerror("boolean value expected"); }
#line 3600 "cfg.tab.c"
    break;

  case 175: /* assign_stm: TCP_WORKERS EQUAL NUMBER  */
#line 982 "cfg.y"
                                           { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 3608 "cfg.tab.c"
    break;

  case 176: /* assign_stm: TCP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 985 "cfg.y"
                                                                      { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3617 "cfg.tab.c"
    break;

  case 177: /* assign_stm: TCP_WORKERS EQUAL error  */
#line 989 "cfg.y"
                                          { yyerror("number expected"); }
#line 3623 "cfg.tab.c"
    break;

  case 178: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL NUMBER  */
#line 990 "cfg.y"
                                                   { IFOR();
				if ((yyvsp[0].intval) <= 0)
					yyerror("invalid 'tcp_connect_timeout' (value too low!)");
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 3633 "cfg.tab.c"
    break;

  case 179: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 995 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3639 "cfg.tab.c"
    break;

  case 180: /* assign_stm: TCP_CON_LIFETIME EQUAL NUMBER  */
#line 996 "cfg.y"
                                                { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 3647 "cfg.tab.c"
    break;

  case 181: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 999 "cfg.y"
                                               { yyerror("number expected"); }
#line 3653 "cfg.tab.c"
    break;

  case 182: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL NUMBER  */
#line 1000 "cfg.y"
                                                  { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3661 "cfg.tab.c"
    break;

  case 183: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL error  */
#line 1003 "cfg.y"
                                                 { yyerror("number expected"); }
#line 3667 "cfg.tab.c"
    break;

  case 184: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1004 "cfg.y"
                                                   { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 3675 "cfg.tab.c"
    break;

  case 185: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 1007 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3681 "cfg.tab.c"
    break;

  case 186: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL ID  */
#line 1008 "cfg.y"
                                                 { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 3693 "cfg.tab.c"
    break;

  case 187: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL error  */
#line 1015 "cfg.y"
                                                    { yyerror("number value expected"); }
#line 3699 "cfg.tab.c"
    break;

  case 188: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL ID  */
#line 1016 "cfg.y"
                                                   { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 3711 "cfg.tab.c"
    break;

  case 189: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL error  */
#line 1023 "cfg.y"
                                                      { yyerror("number value expected"); }
#line 3717 "cfg.tab.c"
    break;

  case 190: /* assign_stm: TCP_KEEPALIVE EQUAL NUMBER  */
#line 1025 "cfg.y"
                                             { IFOR();
				tcp_keepalive=!!(yyvsp[0].intval);
		}
#line 3725 "cfg.tab.c"
    break;

  case 191: /* assign_stm: TCP_KEEPALIVE EQUAL error  */
#line 1028 "cfg.y"
                                            { yyerror("boolean value expected"); }
#line 3731 "cfg.tab.c"
    break;

  case 192: /* assign_stm: TCP_MAX_MSG_TIME EQUAL NUMBER  */
#line 1029 "cfg.y"
                                                { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 3739 "cfg.tab.c"
    break;

  case 193: /* assign_stm: TCP_MAX_MSG_TIME EQUAL error  */
#line 1032 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3745 "cfg.tab.c"
    break;

  case 194: /* assign_stm: TCP_PARALLEL_READ_ON_WORKERS EQUAL NUMBER  */
#line 1033 "cfg.y"
                                                            { IFOR();
				tcp_parallel_read_on_workers=!!(yyvsp[0].intval);
		}
#line 3753 "cfg.tab.c"
    break;

  case 195: /* assign_stm: TCP_PARALLEL_READ_ON_WORKERS EQUAL error  */
#line 1036 "cfg.y"
                                                           {
			yyerror("boolean value expected");
		}
#line 3761 "cfg.tab.c"
    break;

  case 196: /* assign_stm: TCP_KEEPCOUNT EQUAL NUMBER  */
#line 1039 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 3773 "cfg.tab.c"
    break;

  case 197: /* assign_stm: TCP_KEEPCOUNT EQUAL error  */
#line 1046 "cfg.y"
                                            { yyerror("int value expected"); }
#line 3779 "cfg.tab.c"
    break;

  case 198: /* assign_stm: TCP_KEEPIDLE EQUAL NUMBER  */
#line 1047 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 3791 "cfg.tab.c"
    break;

  case 199: /* assign_stm: TCP_KEEPIDLE EQUAL error  */
#line 1054 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3797 "cfg.tab.c"
    break;

  case 200: /* assign_stm: TCP_KEEPINTERVAL EQUAL NUMBER  */
#line 1055 "cfg.y"
                                                { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 3809 "cfg.tab.c"
    break;

  case 201: /* assign_stm: TCP_KEEPINTERVAL EQUAL error  */
#line 1062 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3815 "cfg.tab.c"
    break;

  case 202: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1063 "cfg.y"
                                                { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 3822 "cfg.tab.c"
    break;

  case 203: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1065 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3828 "cfg.tab.c"
    break;

  case 204: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1066 "cfg.y"
                                             { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 3837 "cfg.tab.c"
    break;

  case 205: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1070 "cfg.y"
                                            { yyerror("string value expected"); }
#line 3843 "cfg.tab.c"
    break;

  case 206: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1071 "cfg.y"
                                                 { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 3851 "cfg.tab.c"
    break;

  case 207: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1074 "cfg.y"
                                                { yyerror("string value expected"); }
#line 3857 "cfg.tab.c"
    break;

  case 208: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL NUMBER  */
#line 1075 "cfg.y"
                                                 { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 3864 "cfg.tab.c"
    break;

  case 209: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL error  */
#line 1077 "cfg.y"
                                                { yyerror("number expected"); }
#line 3870 "cfg.tab.c"
    break;

  case 210: /* assign_stm: XLOG_BUF_SIZE EQUAL NUMBER  */
#line 1078 "cfg.y"
                                             { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 3877 "cfg.tab.c"
    break;

  case 211: /* assign_stm: XLOG_FORCE_COLOR EQUAL NUMBER  */
#line 1080 "cfg.y"
                                                { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 3884 "cfg.tab.c"
    break;

  case 212: /* assign_stm: XLOG_PRINT_LEVEL EQUAL NUMBER  */
#line 1082 "cfg.y"
                                                { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 3891 "cfg.tab.c"
    break;

  case 213: /* assign_stm: XLOG_BUF_SIZE EQUAL error  */
#line 1084 "cfg.y"
                                            { yyerror("number expected"); }
#line 3897 "cfg.tab.c"
    break;

  case 214: /* assign_stm: XLOG_FORCE_COLOR EQUAL error  */
#line 1085 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3903 "cfg.tab.c"
    break;

  case 215: /* assign_stm: XLOG_PRINT_LEVEL EQUAL error  */
#line 1086 "cfg.y"
                                               { yyerror("number expected"); }
#line 3909 "cfg.tab.c"
    break;

  case 216: /* assign_stm: XLOG_LEVEL EQUAL snumber  */
#line 1087 "cfg.y"
                                           { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 3916 "cfg.tab.c"
    break;

  case 217: /* assign_stm: XLOG_LEVEL EQUAL error  */
#line 1089 "cfg.y"
                                         { yyerror("number expected"); }
#line 3922 "cfg.tab.c"
    break;

  case 218: /* assign_stm: SOCKET EQUAL socket_def  */
#line 1090 "cfg.y"
                                          { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 3934 "cfg.tab.c"
    break;

  case 219: /* assign_stm: SOCKET EQUAL error  */
#line 1097 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 3942 "cfg.tab.c"
    break;

  case 220: /* assign_stm: LISTEN EQUAL socket_def  */
#line 1100 "cfg.y"
                                          { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 3955 "cfg.tab.c"
    break;

  case 221: /* assign_stm: LISTEN EQUAL error  */
#line 1108 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 3963 "cfg.tab.c"
    break;

  case 222: /* assign_stm: MEMGROUP EQUAL STRING COLON multi_string  */
#line 1111 "cfg.y"
                                                           { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4012 "cfg.tab.c"
    break;

  case 223: /* assign_stm: MEMGROUP EQUAL STRING COLON error  */
#line 1155 "cfg.y"
                                                    { yyerror("invalid or no module specified"); }
#line 4018 "cfg.tab.c"
    break;

  case 224: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1156 "cfg.y"
                                      { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4028 "cfg.tab.c"
    break;

  case 225: /* assign_stm: ALIAS EQUAL error  */
#line 1161 "cfg.y"
                                      { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4035 "cfg.tab.c"
    break;

  case 226: /* assign_stm: AUTO_ALIASES EQUAL NUMBER  */
#line 1163 "cfg.y"
                                            { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4042 "cfg.tab.c"
    break;

  case 227: /* assign_stm: AUTO_ALIASES EQUAL error  */
#line 1165 "cfg.y"
                                            { yyerror("number  expected"); }
#line 4048 "cfg.tab.c"
    break;

  case 228: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1166 "cfg.y"
                                                     { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4059 "cfg.tab.c"
    break;

  case 229: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1172 "cfg.y"
                                                 {yyerror("ip address or hostname "
												"expected"); }
#line 4066 "cfg.tab.c"
    break;

  case 230: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1174 "cfg.y"
                                               { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4085 "cfg.tab.c"
    break;

  case 231: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1188 "cfg.y"
                                             {yyerror("ip address or hostname "
												"expected"); }
#line 4092 "cfg.tab.c"
    break;

  case 232: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1190 "cfg.y"
                                            { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4100 "cfg.tab.c"
    break;

  case 233: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1193 "cfg.y"
                                           { yyerror("boolean value expected"); }
#line 4106 "cfg.tab.c"
    break;

  case 234: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1194 "cfg.y"
                                             { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4114 "cfg.tab.c"
    break;

  case 235: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1197 "cfg.y"
                                            { yyerror("number expected"); }
#line 4120 "cfg.tab.c"
    break;

  case 236: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1198 "cfg.y"
                                              { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4132 "cfg.tab.c"
    break;

  case 237: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1205 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4138 "cfg.tab.c"
    break;

  case 238: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1206 "cfg.y"
                                         { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4150 "cfg.tab.c"
    break;

  case 239: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1213 "cfg.y"
                                        { yyerror("number expected as tos"); }
#line 4156 "cfg.tab.c"
    break;

  case 240: /* assign_stm: TOS EQUAL NUMBER  */
#line 1214 "cfg.y"
                                   { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4165 "cfg.tab.c"
    break;

  case 241: /* assign_stm: TOS EQUAL ID  */
#line 1218 "cfg.y"
                               { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4198 "cfg.tab.c"
    break;

  case 242: /* assign_stm: TOS EQUAL error  */
#line 1246 "cfg.y"
                                  { yyerror("number expected"); }
#line 4204 "cfg.tab.c"
    break;

  case 243: /* assign_stm: MPATH EQUAL STRING  */
#line 1247 "cfg.y"
                                     {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4211 "cfg.tab.c"
    break;

  case 244: /* assign_stm: MPATH EQUAL error  */
#line 1249 "cfg.y"
                                     { yyerror("string value expected"); }
#line 4217 "cfg.tab.c"
    break;

  case 245: /* assign_stm: DISABLE_DNS_FAILOVER EQUAL NUMBER  */
#line 1250 "cfg.y"
                                                    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4225 "cfg.tab.c"
    break;

  case 246: /* assign_stm: DISABLE_DNS_FAILOVER error  */
#line 1253 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4231 "cfg.tab.c"
    break;

  case 247: /* assign_stm: DISABLE_DNS_BLACKLIST EQUAL NUMBER  */
#line 1254 "cfg.y"
                                                     { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4239 "cfg.tab.c"
    break;

  case 248: /* assign_stm: DISABLE_DNS_BLACKLIST error  */
#line 1257 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 4245 "cfg.tab.c"
    break;

  case 249: /* assign_stm: DST_BLACKLIST EQUAL ID COLON LBRACE blst_elem_list RBRACE  */
#line 1258 "cfg.y"
                                                                            { IFOR();
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4260 "cfg.tab.c"
    break;

  case 250: /* assign_stm: DISABLE_STATELESS_FWD EQUAL NUMBER  */
#line 1268 "cfg.y"
                                                     { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4267 "cfg.tab.c"
    break;

  case 251: /* assign_stm: DB_VERSION_TABLE EQUAL STRING  */
#line 1270 "cfg.y"
                                                { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4274 "cfg.tab.c"
    break;

  case 252: /* assign_stm: DB_VERSION_TABLE EQUAL error  */
#line 1272 "cfg.y"
                                               { yyerror("string value expected"); }
#line 4280 "cfg.tab.c"
    break;

  case 253: /* assign_stm: DB_DEFAULT_URL EQUAL STRING  */
#line 1273 "cfg.y"
                                              { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4287 "cfg.tab.c"
    break;

  case 254: /* assign_stm: DB_DEFAULT_URL EQUAL error  */
#line 1275 "cfg.y"
                                             { yyerror("string value expected"); }
#line 4293 "cfg.tab.c"
    break;

  case 255: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL NUMBER  */
#line 1276 "cfg.y"
                                                        { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4300 "cfg.tab.c"
    break;

  case 256: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL error  */
#line 1278 "cfg.y"
                                                       {
				yyerror("integer value expected");
				}
#line 4308 "cfg.tab.c"
    break;

  case 257: /* assign_stm: DISABLE_503_TRANSLATION EQUAL NUMBER  */
#line 1281 "cfg.y"
                                                       { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4315 "cfg.tab.c"
    break;

  case 258: /* assign_stm: DISABLE_503_TRANSLATION EQUAL error  */
#line 1283 "cfg.y"
                                                      {
				yyerror("integer value expected");
				}
#line 4323 "cfg.tab.c"
    break;

  case 259: /* assign_stm: AUTO_SCALING_PROFILE EQUAL auto_scale_profile_def  */
#line 1286 "cfg.y"
                                                                    {}
#line 4329 "cfg.tab.c"
    break;

  case 260: /* assign_stm: AUTO_SCALING_PROFILE EQUAL error  */
#line 1287 "cfg.y"
                                                   {
				yyerror("bad auto-scaling profile definition");
				}
#line 4337 "cfg.tab.c"
    break;

  case 261: /* assign_stm: AUTO_SCALING_CYCLE EQUAL NUMBER  */
#line 1290 "cfg.y"
                                                  { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4344 "cfg.tab.c"
    break;

  case 262: /* assign_stm: AUTO_SCALING_CYCLE EQUAL error  */
#line 1292 "cfg.y"
                                                 {
				yyerror("integer value expected");
				}
#line 4352 "cfg.tab.c"
    break;

  case 263: /* assign_stm: error EQUAL  */
#line 1295 "cfg.y"
                              { yyerror("unknown config variable"); }
#line 4358 "cfg.tab.c"
    break;

  case 264: /* module_stm: LOADMODULE STRING  */
#line 1298 "cfg.y"
                                        { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4367 "cfg.tab.c"
    break;

  case 265: /* module_stm: LOADMODULE error  */
#line 1302 "cfg.y"
                                        { yyerror("string expected");  }
#line 4373 "cfg.tab.c"
    break;

  case 266: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 1303 "cfg.y"
                                                                          { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4384 "cfg.tab.c"
    break;

  case 267: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA snumber RPAREN  */
#line 1309 "cfg.y"
                                                                           { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4395 "cfg.tab.c"
    break;

  case 268: /* module_stm: MODPARAM error  */
#line 1315 "cfg.y"
                                 { yyerror("Invalid arguments"); }
#line 4401 "cfg.tab.c"
    break;

  case 269: /* ip: ipv4  */
#line 1319 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4407 "cfg.tab.c"
    break;

  case 270: /* ip: ipv6  */
#line 1320 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4413 "cfg.tab.c"
    break;

  case 271: /* ipv4: IPV4ADDR  */
#line 1323 "cfg.y"
                 {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4432 "cfg.tab.c"
    break;

  case 272: /* ipv6addr: IPV6ADDR  */
#line 1339 "cfg.y"
                         {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 4451 "cfg.tab.c"
    break;

  case 273: /* ipv6: ipv6addr  */
#line 1355 "cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4457 "cfg.tab.c"
    break;

  case 274: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 1356 "cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 4463 "cfg.tab.c"
    break;

  case 275: /* ipnet: IPNET  */
#line 1359 "cfg.y"
                {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 4474 "cfg.tab.c"
    break;

  case 276: /* ipnet: ip  */
#line 1365 "cfg.y"
                        {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 4483 "cfg.tab.c"
    break;

  case 277: /* folded_string: STRING STRING  */
#line 1375 "cfg.y"
                              {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4498 "cfg.tab.c"
    break;

  case 278: /* folded_string: folded_string STRING  */
#line 1385 "cfg.y"
                                       {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4513 "cfg.tab.c"
    break;

  case 279: /* route_name: ID  */
#line 1396 "cfg.y"
                {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 4521 "cfg.tab.c"
    break;

  case 280: /* route_name: NUMBER  */
#line 1399 "cfg.y"
                         {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 4535 "cfg.tab.c"
    break;

  case 281: /* route_name: STRING  */
#line 1408 "cfg.y"
                        {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 4543 "cfg.tab.c"
    break;

  case 282: /* route_name_var: route_name  */
#line 1413 "cfg.y"
                           {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 4571 "cfg.tab.c"
    break;

  case 283: /* route_name_var: script_var  */
#line 1436 "cfg.y"
                             {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 4580 "cfg.tab.c"
    break;

  case 284: /* route_stm: ROUTE LBRACE actions RBRACE  */
#line 1441 "cfg.y"
                                        {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 4593 "cfg.tab.c"
    break;

  case 285: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1449 "cfg.y"
                                                                       {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 4614 "cfg.tab.c"
    break;

  case 286: /* route_stm: ROUTE error  */
#line 1465 "cfg.y"
                              { yyerror("invalid  route  statement"); }
#line 4620 "cfg.tab.c"
    break;

  case 287: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1468 "cfg.y"
                                                                                {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 4631 "cfg.tab.c"
    break;

  case 288: /* failure_route_stm: ROUTE_FAILURE error  */
#line 1474 "cfg.y"
                                      { yyerror("invalid failure_route statement"); }
#line 4637 "cfg.tab.c"
    break;

  case 289: /* onreply_route_stm: ROUTE_ONREPLY LBRACE actions RBRACE  */
#line 1477 "cfg.y"
                                                       {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 4650 "cfg.tab.c"
    break;

  case 290: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1485 "cfg.y"
                                                                               {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 4661 "cfg.tab.c"
    break;

  case 291: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 1491 "cfg.y"
                                      { yyerror("invalid onreply_route statement"); }
#line 4667 "cfg.tab.c"
    break;

  case 292: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1494 "cfg.y"
                                                                              {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 4678 "cfg.tab.c"
    break;

  case 293: /* branch_route_stm: ROUTE_BRANCH error  */
#line 1500 "cfg.y"
                                     { yyerror("invalid branch_route statement"); }
#line 4684 "cfg.tab.c"
    break;

  case 294: /* error_route_stm: ROUTE_ERROR LBRACE actions RBRACE  */
#line 1503 "cfg.y"
                                                    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 4697 "cfg.tab.c"
    break;

  case 295: /* error_route_stm: ROUTE_ERROR error  */
#line 1511 "cfg.y"
                                    { yyerror("invalid error_route statement"); }
#line 4703 "cfg.tab.c"
    break;

  case 296: /* local_route_stm: ROUTE_LOCAL LBRACE actions RBRACE  */
#line 1514 "cfg.y"
                                                    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 4716 "cfg.tab.c"
    break;

  case 297: /* local_route_stm: ROUTE_LOCAL error  */
#line 1522 "cfg.y"
                                    { yyerror("invalid local_route statement"); }
#line 4722 "cfg.tab.c"
    break;

  case 298: /* startup_route_stm: ROUTE_STARTUP LBRACE actions RBRACE  */
#line 1525 "cfg.y"
                                                        {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 4735 "cfg.tab.c"
    break;

  case 299: /* startup_route_stm: ROUTE_STARTUP error  */
#line 1533 "cfg.y"
                                      { yyerror("invalid startup_route statement"); }
#line 4741 "cfg.tab.c"
    break;

  case 300: /* timer_route_stm: ROUTE_TIMER LBRACK route_name COMMA NUMBER RBRACK LBRACE actions RBRACE  */
#line 1536 "cfg.y"
                                                                                          {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 4759 "cfg.tab.c"
    break;

  case 301: /* timer_route_stm: ROUTE_TIMER error  */
#line 1549 "cfg.y"
                                    { yyerror("invalid timer_route statement"); }
#line 4765 "cfg.tab.c"
    break;

  case 302: /* event_route_stm: ROUTE_EVENT LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1552 "cfg.y"
                                                                            {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 4776 "cfg.tab.c"
    break;

  case 303: /* event_route_stm: ROUTE_EVENT error  */
#line 1558 "cfg.y"
                                    { yyerror("invalid event_route statement"); }
#line 4782 "cfg.tab.c"
    break;

  case 304: /* exp: exp AND exp  */
#line 1563 "cfg.y"
                        { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4788 "cfg.tab.c"
    break;

  case 305: /* exp: exp OR exp  */
#line 1564 "cfg.y"
                                { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 4794 "cfg.tab.c"
    break;

  case 306: /* exp: NOT exp  */
#line 1565 "cfg.y"
                                        { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 4800 "cfg.tab.c"
    break;

  case 307: /* exp: LPAREN exp RPAREN  */
#line 1566 "cfg.y"
                                { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 4806 "cfg.tab.c"
    break;

  case 308: /* exp: LBRACK assignexp RBRACK  */
#line 1567 "cfg.y"
                                  { (yyval.expr)=(yyvsp[-1].expr); }
#line 4812 "cfg.tab.c"
    break;

  case 309: /* exp: exp_elem  */
#line 1568 "cfg.y"
                                        { (yyval.expr)=(yyvsp[0].expr); }
#line 4818 "cfg.tab.c"
    break;

  case 310: /* equalop: EQUAL_T  */
#line 1571 "cfg.y"
                          {(yyval.intval)=EQUAL_OP; }
#line 4824 "cfg.tab.c"
    break;

  case 311: /* equalop: DIFF  */
#line 1572 "cfg.y"
                                {(yyval.intval)=DIFF_OP; }
#line 4830 "cfg.tab.c"
    break;

  case 312: /* compop: GT  */
#line 1575 "cfg.y"
                {(yyval.intval)=GT_OP; }
#line 4836 "cfg.tab.c"
    break;

  case 313: /* compop: LT  */
#line 1576 "cfg.y"
                        {(yyval.intval)=LT_OP; }
#line 4842 "cfg.tab.c"
    break;

  case 314: /* compop: GTE  */
#line 1577 "cfg.y"
                        {(yyval.intval)=GTE_OP; }
#line 4848 "cfg.tab.c"
    break;

  case 315: /* compop: LTE  */
#line 1578 "cfg.y"
                        {(yyval.intval)=LTE_OP; }
#line 4854 "cfg.tab.c"
    break;

  case 316: /* matchop: MATCH  */
#line 1580 "cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 4860 "cfg.tab.c"
    break;

  case 317: /* matchop: NOTMATCH  */
#line 1581 "cfg.y"
                                {(yyval.intval)=NOTMATCH_OP; }
#line 4866 "cfg.tab.c"
    break;

  case 318: /* intop: equalop  */
#line 1584 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 4872 "cfg.tab.c"
    break;

  case 319: /* intop: compop  */
#line 1585 "cfg.y"
                        {(yyval.intval)=(yyvsp[0].intval); }
#line 4878 "cfg.tab.c"
    break;

  case 320: /* strop: equalop  */
#line 1588 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 4884 "cfg.tab.c"
    break;

  case 321: /* strop: compop  */
#line 1589 "cfg.y"
                     {(yyval.intval)=(yyvsp[0].intval); }
#line 4890 "cfg.tab.c"
    break;

  case 322: /* strop: matchop  */
#line 1590 "cfg.y"
                                {(yyval.intval)=(yyvsp[0].intval); }
#line 4896 "cfg.tab.c"
    break;

  case 323: /* script_var: SCRIPTVAR  */
#line 1593 "cfg.y"
                                {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 4917 "cfg.tab.c"
    break;

  case 324: /* script_var: SCRIPTVARERR  */
#line 1609 "cfg.y"
                               {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 4925 "cfg.tab.c"
    break;

  case 325: /* exp_elem: exp_cond  */
#line 1614 "cfg.y"
                                {(yyval.expr)=(yyvsp[0].expr); }
#line 4931 "cfg.tab.c"
    break;

  case 326: /* exp_elem: exp_stm  */
#line 1615 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 4937 "cfg.tab.c"
    break;

  case 327: /* exp_elem: snumber  */
#line 1616 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 4944 "cfg.tab.c"
    break;

  case 328: /* exp_elem: script_var  */
#line 1618 "cfg.y"
                                {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 4952 "cfg.tab.c"
    break;

  case 329: /* exp_cond: script_var strop script_var  */
#line 1623 "cfg.y"
                                      {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 4960 "cfg.tab.c"
    break;

  case 330: /* exp_cond: script_var strop STRING  */
#line 1626 "cfg.y"
                                          {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 4968 "cfg.tab.c"
    break;

  case 331: /* exp_cond: script_var intop snumber  */
#line 1629 "cfg.y"
                                           {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 4976 "cfg.tab.c"
    break;

  case 332: /* exp_cond: script_var equalop NULLV  */
#line 1632 "cfg.y"
                                                {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 4984 "cfg.tab.c"
    break;

  case 333: /* exp_cond: script_var equalop ipnet  */
#line 1635 "cfg.y"
                                           {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 4992 "cfg.tab.c"
    break;

  case 334: /* assignop: EQUAL  */
#line 1641 "cfg.y"
              { (yyval.intval) = EQ_T; }
#line 4998 "cfg.tab.c"
    break;

  case 335: /* assignop: COLONEQ  */
#line 1642 "cfg.y"
                  { (yyval.intval) = COLONEQ_T; }
#line 5004 "cfg.tab.c"
    break;

  case 336: /* assignop: PLUSEQ  */
#line 1643 "cfg.y"
                 { (yyval.intval) = PLUSEQ_T; }
#line 5010 "cfg.tab.c"
    break;

  case 337: /* assignop: MINUSEQ  */
#line 1644 "cfg.y"
                  { (yyval.intval) = MINUSEQ_T;}
#line 5016 "cfg.tab.c"
    break;

  case 338: /* assignop: SLASHEQ  */
#line 1645 "cfg.y"
                  { (yyval.intval) = DIVEQ_T; }
#line 5022 "cfg.tab.c"
    break;

  case 339: /* assignop: MULTEQ  */
#line 1646 "cfg.y"
                 { (yyval.intval) = MULTEQ_T; }
#line 5028 "cfg.tab.c"
    break;

  case 340: /* assignop: MODULOEQ  */
#line 1647 "cfg.y"
                   { (yyval.intval) = MODULOEQ_T; }
#line 5034 "cfg.tab.c"
    break;

  case 341: /* assignop: BANDEQ  */
#line 1648 "cfg.y"
                 { (yyval.intval) = BANDEQ_T; }
#line 5040 "cfg.tab.c"
    break;

  case 342: /* assignop: BOREQ  */
#line 1649 "cfg.y"
                { (yyval.intval) = BOREQ_T; }
#line 5046 "cfg.tab.c"
    break;

  case 343: /* assignop: BXOREQ  */
#line 1650 "cfg.y"
                 { (yyval.intval) = BXOREQ_T; }
#line 5052 "cfg.tab.c"
    break;

  case 344: /* assignexp: snumber  */
#line 1654 "cfg.y"
                { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5058 "cfg.tab.c"
    break;

  case 345: /* assignexp: STRING  */
#line 1655 "cfg.y"
                 { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5064 "cfg.tab.c"
    break;

  case 346: /* assignexp: script_var  */
#line 1656 "cfg.y"
                     { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5070 "cfg.tab.c"
    break;

  case 347: /* assignexp: exp_cond  */
#line 1657 "cfg.y"
                   { (yyval.expr)= (yyvsp[0].expr); }
#line 5076 "cfg.tab.c"
    break;

  case 348: /* assignexp: cmd  */
#line 1658 "cfg.y"
              { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5082 "cfg.tab.c"
    break;

  case 349: /* assignexp: assignexp PLUS assignexp  */
#line 1659 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5090 "cfg.tab.c"
    break;

  case 350: /* assignexp: assignexp MINUS assignexp  */
#line 1662 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5098 "cfg.tab.c"
    break;

  case 351: /* assignexp: assignexp MULT assignexp  */
#line 1665 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5106 "cfg.tab.c"
    break;

  case 352: /* assignexp: assignexp SLASH assignexp  */
#line 1668 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5114 "cfg.tab.c"
    break;

  case 353: /* assignexp: assignexp MODULO assignexp  */
#line 1671 "cfg.y"
                                     {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5122 "cfg.tab.c"
    break;

  case 354: /* assignexp: assignexp BAND assignexp  */
#line 1674 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5130 "cfg.tab.c"
    break;

  case 355: /* assignexp: assignexp BOR assignexp  */
#line 1677 "cfg.y"
                                  {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5138 "cfg.tab.c"
    break;

  case 356: /* assignexp: assignexp BXOR assignexp  */
#line 1680 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5146 "cfg.tab.c"
    break;

  case 357: /* assignexp: assignexp BLSHIFT assignexp  */
#line 1683 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5154 "cfg.tab.c"
    break;

  case 358: /* assignexp: assignexp BRSHIFT assignexp  */
#line 1686 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5162 "cfg.tab.c"
    break;

  case 359: /* assignexp: BNOT assignexp  */
#line 1689 "cfg.y"
                         {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5170 "cfg.tab.c"
    break;

  case 360: /* assignexp: LPAREN assignexp RPAREN  */
#line 1692 "cfg.y"
                                  { (yyval.expr) = (yyvsp[-1].expr); }
#line 5176 "cfg.tab.c"
    break;

  case 361: /* assign_cmd: script_var assignop assignexp  */
#line 1695 "cfg.y"
                                          {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5194 "cfg.tab.c"
    break;

  case 362: /* assign_cmd: script_var EQUAL NULLV  */
#line 1708 "cfg.y"
                                  {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5212 "cfg.tab.c"
    break;

  case 363: /* assign_cmd: script_var COLONEQ NULLV  */
#line 1721 "cfg.y"
                                    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5230 "cfg.tab.c"
    break;

  case 364: /* exp_stm: cmd  */
#line 1736 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5236 "cfg.tab.c"
    break;

  case 365: /* exp_stm: if_cmd  */
#line 1737 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5242 "cfg.tab.c"
    break;

  case 366: /* exp_stm: assign_cmd  */
#line 1738 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5248 "cfg.tab.c"
    break;

  case 367: /* exp_stm: LBRACE actions RBRACE  */
#line 1739 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5254 "cfg.tab.c"
    break;

  case 368: /* exp_stm: LBRACE RBRACE  */
#line 1740 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5260 "cfg.tab.c"
    break;

  case 369: /* brk_stm: brk_action  */
#line 1743 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5266 "cfg.tab.c"
    break;

  case 370: /* brk_stm: LBRACE brk_actions RBRACE  */
#line 1744 "cfg.y"
                                                        { (yyval.action)=(yyvsp[-1].action); }
#line 5272 "cfg.tab.c"
    break;

  case 371: /* brk_stm: LBRACE RBRACE  */
#line 1745 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5278 "cfg.tab.c"
    break;

  case 372: /* stm: action  */
#line 1748 "cfg.y"
                                                        { (yyval.action)=(yyvsp[0].action); }
#line 5284 "cfg.tab.c"
    break;

  case 373: /* stm: LBRACE actions RBRACE  */
#line 1749 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5290 "cfg.tab.c"
    break;

  case 374: /* stm: LBRACE RBRACE  */
#line 1750 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5296 "cfg.tab.c"
    break;

  case 375: /* actions: actions action  */
#line 1753 "cfg.y"
                                {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5302 "cfg.tab.c"
    break;

  case 376: /* actions: action  */
#line 1754 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5308 "cfg.tab.c"
    break;

  case 377: /* actions: actions error  */
#line 1755 "cfg.y"
                                { (yyval.action)=0; yyerror("bad command!)"); }
#line 5314 "cfg.tab.c"
    break;

  case 378: /* brk_actions: brk_actions brk_action  */
#line 1759 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5320 "cfg.tab.c"
    break;

  case 379: /* brk_actions: brk_action  */
#line 1760 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5326 "cfg.tab.c"
    break;

  case 380: /* brk_actions: brk_actions error  */
#line 1761 "cfg.y"
                                    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5332 "cfg.tab.c"
    break;

  case 381: /* action: cmd SEMICOLON  */
#line 1764 "cfg.y"
                              {(yyval.action)=(yyvsp[-1].action);}
#line 5338 "cfg.tab.c"
    break;

  case 382: /* action: if_cmd  */
#line 1765 "cfg.y"
                         {(yyval.action)=(yyvsp[0].action);}
#line 5344 "cfg.tab.c"
    break;

  case 383: /* action: while_cmd  */
#line 1766 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5350 "cfg.tab.c"
    break;

  case 384: /* action: foreach_cmd  */
#line 1767 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5356 "cfg.tab.c"
    break;

  case 385: /* action: switch_cmd  */
#line 1768 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5362 "cfg.tab.c"
    break;

  case 386: /* action: assign_cmd SEMICOLON  */
#line 1769 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5368 "cfg.tab.c"
    break;

  case 387: /* action: SEMICOLON  */
#line 1770 "cfg.y"
                                              {(yyval.action)=0;}
#line 5374 "cfg.tab.c"
    break;

  case 388: /* action: cmd error  */
#line 1771 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5380 "cfg.tab.c"
    break;

  case 389: /* brk_action: BREAK SEMICOLON  */
#line 1774 "cfg.y"
                            { mk_action0((yyval.action), BREAK_T);}
#line 5386 "cfg.tab.c"
    break;

  case 390: /* brk_action: cmd SEMICOLON  */
#line 1775 "cfg.y"
                                {(yyval.action)=(yyvsp[-1].action);}
#line 5392 "cfg.tab.c"
    break;

  case 391: /* brk_action: brk_if_cmd  */
#line 1776 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5398 "cfg.tab.c"
    break;

  case 392: /* brk_action: while_cmd  */
#line 1777 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5404 "cfg.tab.c"
    break;

  case 393: /* brk_action: foreach_cmd  */
#line 1778 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5410 "cfg.tab.c"
    break;

  case 394: /* brk_action: switch_cmd  */
#line 1779 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5416 "cfg.tab.c"
    break;

  case 395: /* brk_action: assign_cmd SEMICOLON  */
#line 1780 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5422 "cfg.tab.c"
    break;

  case 396: /* brk_action: SEMICOLON  */
#line 1781 "cfg.y"
                                              {(yyval.action)=0;}
#line 5428 "cfg.tab.c"
    break;

  case 397: /* brk_action: cmd error  */
#line 1782 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5434 "cfg.tab.c"
    break;

  case 398: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm  */
#line 1785 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5447 "cfg.tab.c"
    break;

  case 399: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm ELSE brk_stm  */
#line 1793 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5460 "cfg.tab.c"
    break;

  case 400: /* if_cmd: IF LPAREN exp RPAREN stm  */
#line 1803 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5473 "cfg.tab.c"
    break;

  case 401: /* if_cmd: IF LPAREN exp RPAREN stm ELSE stm  */
#line 1811 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5486 "cfg.tab.c"
    break;

  case 402: /* while_cmd: WHILE LPAREN exp RPAREN brk_stm  */
#line 1821 "cfg.y"
                                                        { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 5497 "cfg.tab.c"
    break;

  case 403: /* foreach_cmd: FOR LPAREN script_var IN script_var RPAREN brk_stm  */
#line 1829 "cfg.y"
                                                                   {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 5518 "cfg.tab.c"
    break;

  case 404: /* switch_cmd: SWITCH LPAREN script_var RPAREN LBRACE switch_stm RBRACE  */
#line 1847 "cfg.y"
                                                                                        {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 5530 "cfg.tab.c"
    break;

  case 405: /* switch_stm: case_stms default_stm  */
#line 1856 "cfg.y"
                                  { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5536 "cfg.tab.c"
    break;

  case 406: /* switch_stm: case_stms  */
#line 1857 "cfg.y"
                                                { (yyval.action)=(yyvsp[0].action); }
#line 5542 "cfg.tab.c"
    break;

  case 407: /* case_stms: case_stms case_stm  */
#line 1859 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5548 "cfg.tab.c"
    break;

  case 408: /* case_stms: case_stm  */
#line 1860 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5554 "cfg.tab.c"
    break;

  case 409: /* case_stm: CASE snumber COLON brk_actions  */
#line 1863 "cfg.y"
                                         { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 5565 "cfg.tab.c"
    break;

  case 410: /* case_stm: CASE snumber COLON  */
#line 1869 "cfg.y"
                                     { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 5576 "cfg.tab.c"
    break;

  case 411: /* case_stm: CASE STRING COLON brk_actions  */
#line 1875 "cfg.y"
                                                { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 5587 "cfg.tab.c"
    break;

  case 412: /* case_stm: CASE STRING COLON  */
#line 1881 "cfg.y"
                                    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 5598 "cfg.tab.c"
    break;

  case 413: /* default_stm: DEFAULT COLON brk_actions  */
#line 1889 "cfg.y"
                                       { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 5606 "cfg.tab.c"
    break;

  case 414: /* default_stm: DEFAULT COLON  */
#line 1892 "cfg.y"
                                { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 5612 "cfg.tab.c"
    break;

  case 415: /* func_param: STRING  */
#line 1895 "cfg.y"
                   {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 5622 "cfg.tab.c"
    break;

  case 416: /* func_param: func_param COMMA STRING  */
#line 1900 "cfg.y"
                                          {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5637 "cfg.tab.c"
    break;

  case 417: /* func_param: COMMA  */
#line 1910 "cfg.y"
                        {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 5649 "cfg.tab.c"
    break;

  case 418: /* func_param: COMMA STRING  */
#line 1917 "cfg.y"
                               {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 5661 "cfg.tab.c"
    break;

  case 419: /* func_param: func_param COMMA  */
#line 1924 "cfg.y"
                                   {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 5676 "cfg.tab.c"
    break;

  case 420: /* func_param: snumber  */
#line 1934 "cfg.y"
                          {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 5686 "cfg.tab.c"
    break;

  case 421: /* func_param: COMMA snumber  */
#line 1939 "cfg.y"
                                {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 5698 "cfg.tab.c"
    break;

  case 422: /* func_param: func_param COMMA snumber  */
#line 1946 "cfg.y"
                                           {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5713 "cfg.tab.c"
    break;

  case 423: /* func_param: script_var  */
#line 1956 "cfg.y"
                             {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 5723 "cfg.tab.c"
    break;

  case 424: /* func_param: COMMA script_var  */
#line 1961 "cfg.y"
                                   {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 5735 "cfg.tab.c"
    break;

  case 425: /* func_param: func_param COMMA script_var  */
#line 1968 "cfg.y"
                                              {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5750 "cfg.tab.c"
    break;

  case 426: /* route_param: STRING  */
#line 1980 "cfg.y"
                    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 5760 "cfg.tab.c"
    break;

  case 427: /* route_param: snumber  */
#line 1985 "cfg.y"
                          {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 5770 "cfg.tab.c"
    break;

  case 428: /* route_param: NULLV  */
#line 1990 "cfg.y"
                        {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 5780 "cfg.tab.c"
    break;

  case 429: /* route_param: script_var  */
#line 1995 "cfg.y"
                             {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 5790 "cfg.tab.c"
    break;

  case 430: /* route_param: route_param COMMA STRING  */
#line 2000 "cfg.y"
                                           {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5805 "cfg.tab.c"
    break;

  case 431: /* route_param: route_param COMMA snumber  */
#line 2010 "cfg.y"
                                            {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5820 "cfg.tab.c"
    break;

  case 432: /* route_param: route_param COMMA script_var  */
#line 2020 "cfg.y"
                                               {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5835 "cfg.tab.c"
    break;

  case 433: /* route_param: route_param COMMA NULLV  */
#line 2030 "cfg.y"
                                          {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5850 "cfg.tab.c"
    break;

  case 434: /* async_func: ID LPAREN RPAREN  */
#line 2042 "cfg.y"
                             {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-2].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(cmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 5873 "cfg.tab.c"
    break;

  case 435: /* async_func: ID LPAREN func_param RPAREN  */
#line 2060 "cfg.y"
                                                      {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-3].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 5909 "cfg.tab.c"
    break;

  case 436: /* async_func: ID LPAREN error RPAREN  */
#line 2091 "cfg.y"
                                                 {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 5918 "cfg.tab.c"
    break;

  case 437: /* async_func: ID error  */
#line 2095 "cfg.y"
                                   {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 5927 "cfg.tab.c"
    break;

  case 438: /* cmd: ASSERT LPAREN exp COMMA STRING RPAREN  */
#line 2101 "cfg.y"
                                                 {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 5935 "cfg.tab.c"
    break;

  case 439: /* cmd: DROP  */
#line 2104 "cfg.y"
                                                 {mk_action0( (yyval.action), DROP_T); }
#line 5941 "cfg.tab.c"
    break;

  case 440: /* cmd: DROP LPAREN RPAREN  */
#line 2105 "cfg.y"
                                     {mk_action0( (yyval.action), DROP_T); }
#line 5947 "cfg.tab.c"
    break;

  case 441: /* cmd: EXIT  */
#line 2106 "cfg.y"
                                                 {mk_action0( (yyval.action), EXIT_T); }
#line 5953 "cfg.tab.c"
    break;

  case 442: /* cmd: EXIT LPAREN RPAREN  */
#line 2107 "cfg.y"
                                     {mk_action0( (yyval.action), EXIT_T); }
#line 5959 "cfg.tab.c"
    break;

  case 443: /* cmd: RETURN script_var  */
#line 2109 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 5965 "cfg.tab.c"
    break;

  case 444: /* cmd: RETURN LPAREN script_var RPAREN  */
#line 2111 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 5971 "cfg.tab.c"
    break;

  case 445: /* cmd: RETURN snumber  */
#line 2113 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 5977 "cfg.tab.c"
    break;

  case 446: /* cmd: RETURN LPAREN snumber RPAREN  */
#line 2115 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 5983 "cfg.tab.c"
    break;

  case 447: /* cmd: RETURN LPAREN RPAREN  */
#line 2117 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 5989 "cfg.tab.c"
    break;

  case 448: /* cmd: RETURN  */
#line 2118 "cfg.y"
                                                 {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 5995 "cfg.tab.c"
    break;

  case 449: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 2119 "cfg.y"
                                                {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6003 "cfg.tab.c"
    break;

  case 450: /* cmd: LOG_TOK LPAREN snumber COMMA STRING RPAREN  */
#line 2122 "cfg.y"
                                                                {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6014 "cfg.tab.c"
    break;

  case 451: /* cmd: LOG_TOK error  */
#line 2128 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6020 "cfg.tab.c"
    break;

  case 452: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 2129 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6027 "cfg.tab.c"
    break;

  case 453: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 2131 "cfg.y"
                                                          {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6038 "cfg.tab.c"
    break;

  case 454: /* cmd: ERROR error  */
#line 2137 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6044 "cfg.tab.c"
    break;

  case 455: /* cmd: ERROR LPAREN error RPAREN  */
#line 2138 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6051 "cfg.tab.c"
    break;

  case 456: /* cmd: ROUTE LPAREN route_name_var RPAREN  */
#line 2140 "cfg.y"
                                                        {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6059 "cfg.tab.c"
    break;

  case 457: /* cmd: ROUTE LPAREN route_name_var COMMA route_param RPAREN  */
#line 2144 "cfg.y"
                                                                        {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6082 "cfg.tab.c"
    break;

  case 458: /* cmd: ROUTE error  */
#line 2163 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6088 "cfg.tab.c"
    break;

  case 459: /* cmd: ROUTE LPAREN error RPAREN  */
#line 2164 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6095 "cfg.tab.c"
    break;

  case 460: /* cmd: ID LPAREN RPAREN  */
#line 2166 "cfg.y"
                                        {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6123 "cfg.tab.c"
    break;

  case 461: /* cmd: ID LPAREN func_param RPAREN  */
#line 2189 "cfg.y"
                                                {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6164 "cfg.tab.c"
    break;

  case 462: /* cmd: ID LPAREN error RPAREN  */
#line 2225 "cfg.y"
                                         { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6171 "cfg.tab.c"
    break;

  case 463: /* cmd: ID error  */
#line 2227 "cfg.y"
                           { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6179 "cfg.tab.c"
    break;

  case 464: /* cmd: XDBG LPAREN STRING RPAREN  */
#line 2230 "cfg.y"
                                            {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6186 "cfg.tab.c"
    break;

  case 465: /* cmd: XDBG LPAREN folded_string RPAREN  */
#line 2232 "cfg.y"
                                                   {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6193 "cfg.tab.c"
    break;

  case 466: /* cmd: XLOG LPAREN STRING RPAREN  */
#line 2234 "cfg.y"
                                            {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6200 "cfg.tab.c"
    break;

  case 467: /* cmd: XLOG LPAREN folded_string RPAREN  */
#line 2236 "cfg.y"
                                                   {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6207 "cfg.tab.c"
    break;

  case 468: /* cmd: XLOG LPAREN STRING COMMA STRING RPAREN  */
#line 2238 "cfg.y"
                                                         {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6214 "cfg.tab.c"
    break;

  case 469: /* cmd: XLOG LPAREN STRING COMMA folded_string RPAREN  */
#line 2240 "cfg.y"
                                                                {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6221 "cfg.tab.c"
    break;

  case 470: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2242 "cfg.y"
                                                                        {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6232 "cfg.tab.c"
    break;

  case 471: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name COMMA NUMBER RPAREN  */
#line 2248 "cfg.y"
                                                                                     {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (void*)(long)(yyvsp[-1].intval));
				}
#line 6243 "cfg.tab.c"
    break;

  case 472: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name COMMA STRING RPAREN  */
#line 2254 "cfg.y"
                                                                                      {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST, STRING_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (yyvsp[-1].strval));
				}
#line 6254 "cfg.tab.c"
    break;

  case 473: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2260 "cfg.y"
                                                                         {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6265 "cfg.tab.c"
    break;

  case 474: /* cmd: LAUNCH_TOKEN LPAREN async_func RPAREN  */
#line 2266 "cfg.y"
                                                        {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 6274 "cfg.tab.c"
    break;


#line 6278 "cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2273 "cfg.y"


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
